// ._____________________________________.
// |   _   .     .     _____ .____  ___  |
// |  / \  |     |       |   |     /   \ |
// | {---} |     |       |   |__   \___  |
// | |   | |     |       |   |         \ |
// | |   | |____ |____ __|__ |____ \___/ |
// |_____________________________________|

function AIPlayer::ArcherLoop(%bot, %look, %start)
{
	if(%bot.getState() $= "DEAD") return; %bot.updatePos();
	if(CastleDefense.health <= 0) { %bot.dropEverything(); return; }
	cancel(%bot.AILoop); %los = %bot.getEyeVector(); %eye = %bot.getEyePoint(); %pos = %bot.getHackPosition();
	if(!isObject(%bot.getMountedImage(0))) { %bot.mountImage(BowImage, 0); fixArmReady(%bot); }
	%mask = $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType;
	if(%bot.confused)
	{
		for(%i=0;%i<CastleDefense.getCount();%i++)
		{
			%obj = CastleDefense.getObject(%i);
			if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
			if(%obj.getState() $= "DEAD" || %obj.attacker || %obj.confused) continue;
			if(vectorDot(vectorNormalize(vectorSub(%obj.getHackPosition(), %pos)), %los) < 0.25) continue;
			%list[-1+%list++] = %obj;
		}
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(!isObject(%obj = %cl.player) || %obj.attacker || %obj.confused) continue; if(%obj.getState() $= "DEAD") continue;
			if(vectorDot(vectorNormalize(vectorSub(%obj.getHackPosition(), %pos)), %los) < 0.25) continue;
			%list[-1+%list++] = %obj;
		}
	}
	else
	{
		for(%i=0;%i<CastleDefense.getCount();%i++)
		{
			%obj = CastleDefense.getObject(%i);
			if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
			if(%obj.getState() $= "DEAD" || !%obj.attacker) continue;
			if(vectorDot(vectorNormalize(vectorSub(%obj.getHackPosition(), %pos)), %los) < 0.25) continue;
			if(%obj.confused) %conf[-1+%conf++] = %obj;
			else %list[-1+%list++] = %obj;
		}
		if(%list == 0)
		{
			for(%i=0;%i<%conf;%i++)
				%list[%i] = %conf[%i];
			%list = %conf;
		}
	}
	while(!isObject(%targ) && %list != 0)
	{
		%least = ""; %leastArcher = ""; %shift = 0;
		for(%i=0;%i<%list;%i++)
		{
			if(%bot.confused)
			{
				if((%dist = vectorDist(%pos, %list[%i].getHackPosition())) < %least || %least $= "")
				{ %least = %dist; %targ = %list[%i]; }
			}
			else
			{
				if((%dist = vectorDist("0 0", getWords(%list[%i].getHackPosition(), 0, 1))) < %least || %least $= "")
				{ %least = %dist; %targ = %list[%i]; }
			}
			if(%list[%i].type $= "Archer" && (%dist < %leastArcher || %leastArcher $= ""))
			{ %leastArcher = %dist; %targArcher = %list[%i]; }
		}
		if(%least > 45 && isObject(%targArcher)) %targ = %targArcher;
		if(!isObject(%targ)) break;
		if(vectorDist(%pos, %targ.getHackPosition()) >= 5 && (isObject(containerRaycast(%bot.getMuzzlePoint(0), %targ.getEyePoint(), %mask, %bot, %targ)) ||
			(isObject(containerRaycast(%eye, %targ.getHackPosition(), %mask, %bot, %targ)) && isObject(containerRaycast(%eye, %targ.getEyePoint(), %mask, %bot, %targ)))))
		{
			for(%i=0;%i<%list;%i++)
				if(%list[%i] == %targ) %shift++;
				else %list[%i - %shift] = %list[%i];
			%list -= %shift; %targ = ""; %targArcher = "";
		}
	}
	if(isObject(%targ))
	{
		%bot.setAimVector(getFireVector(ArrowProjectile, %bot, %targ));
		%bot.setImageTrigger(0, 1);
	}
	else
	{
		if(vectorDist(%start, getSimTime()) > 2000) %look = "";
		if(%look $= "")
		{
			%ang = getRandom(-314159, 314159) / 100000;
			%look = mSin(%ang) SPC mCos(%ang);
			%start = getSimTime();
		}
		%bot.setAimVector(%look); %bot.setImageTrigger(0, 0);
	}
	%bot.AILoop = %bot.schedule(50, "ArcherLoop", %look, %start);
}

function AIPLayer::KnightLoop(%bot)
{
	if(%bot.getState() $= "DEAD") return; %bot.updatePos();
	if(CastleDefense.health <= 0) { %bot.dropEverything(); return; }
	cancel(%bot.AILoop); %los = %bot.getEyeVector(); %eye = %bot.getEyePoint(); %pos = %bot.getHackPosition();
	%mask = $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType;
	%bot.confused = 0;
	for(%i=0;%i<CastleDefense.getCount();%i++)
	{
		%obj = CastleDefense.getObject(%i);
		if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
		if(%obj.getState() $= "DEAD" || (%bot.confused ? !%obj.attacker && !%obj.confused : %obj.attacker)) continue;
		if(vectorDist(%pos, %obj.getHackPosition()) > 5) continue;
		cancel(%obj.knightAura); %obj.knightAura = schedule(2000, 0, "doNothing");   //The aura lingers slightly after a knight dies.
	}
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%cl = ClientGroup.getObject(%i);
		if(!isObject(%obj = %cl.player) || (%bot.confused ? !%obj.attacker && !%obj.confused : %obj.attacker)) continue; if(%obj.getState() $= "DEAD") continue;
		if(vectorDist(%pos, %obj.getHackPosition()) > 5) continue;
		cancel(%obj.knightAura); %obj.knightAura = schedule(2000, 0, "doNothing");
		//CastleDefense.updateClient(%cl);   //Add a knight aura indicator to the display
	}
	if(%bot.confused)
	{
		for(%i=0;%i<CastleDefense.getCount();%i++)
		{
			%obj = CastleDefense.getObject(%i);
			if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
			if(%obj.getState() $= "DEAD" || %obj.attacker || %obj.confused) continue;
			if(isEventPending(%obj.hasKnightAttacker) && %obj.knightAttacker != %bot) continue;
			if(vectorDot(vectorNormalize(vectorSub(%obj.getHackPosition(), %pos)), %los) < 0.25) continue;
			%list[-1+%list++] = %obj;
		}
	}
	else
	{
		for(%i=0;%i<CastleDefense.getCount();%i++)
		{
			%obj = CastleDefense.getObject(%i);
			if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
			if(%obj.getState() $= "DEAD" || !%obj.attacker || %obj.confused) continue;
			if(isEventPending(%obj.hasKnightAttacker) && %obj.knightAttacker != %bot) continue;
			if(vectorDot(vectorNormalize(vectorSub(%obj.getHackPosition(), %pos)), %los) < 0.25) continue;
			%list[-1+%list++] = %obj;
		}
	}
	while(!isObject(%targ) && %list != 0)
	{
		%least = ""; %shift = 0;
		for(%i=0;%i<%list;%i++)
		{
			if((%dist = vectorDist("0 0", getWords(%list[%i].getHackPosition(), 0, 1))) < %least || %least $= "")
			{ %least = %dist; %targ = %list[%i]; }
		}
		if(!isObject(%targ)) break;
		if(vectorDist(%pos, %targ.getHackPosition()) >= 5 && (isObject(containerRaycast(%bot.getMuzzlePoint(0), %targ.getEyePoint(), %mask, %bot, %targ)) ||
			(isObject(containerRaycast(%eye, %targ.getHackPosition(), %mask, %bot, %targ)) && isObject(containerRaycast(%eye, %targ.getEyePoint(), %mask, %bot, %targ)))))
		{
			for(%i=0;%i<%list;%i++)
				if(%list[%i] == %targ) %shift++;
				else %list[%i - %shift] = %list[%i];
			%list -= %shift; %targ = "";
		}
	}
	if(isObject(%targ))
	{
		if(%targ.getClassName() $= "AIPlayer")
		{
			cancel(%targ.hasKnightAttacker); %targ.knightAttacker = %bot;
			%targ.hasKnightAttacker = schedule(200, 0, "doNothing");
		}
		%bot.setAimVector(%fireDir = getFireVector(SpearProjectile, %bot, %targ));
		if(%bot.getImageState(0) !$= "Armed") %bot.setImageTrigger(0, 1);
		else if(vectorDot(%bot.getMuzzleVector(0), %fireDir) < 0.9999) %bot.setImageTrigger(0, 1);
		else %bot.setImageTrigger(0, 0);
	}
	else
	{
		if(!isObject(%bot.getMountedImage(0))) { %bot.mountImage(SpearImage, 0); fixArmReady(%bot); }
		%bot.setAimVector(getWords(vectorSub(%pos, "0 0"), 0, 1));
		%bot.setImageTrigger(0, 1);
	}
	%bot.AILoop = %bot.schedule(50, "KnightLoop", %last);
}

function AIPlayer::MasonLoop(%bot, %last)
{
	if(%bot.getState() $= "DEAD") return; %bot.updatePos();
	if(CastleDefense.health <= 0) { %bot.dropEverything(); return; }
	cancel(%bot.AILoop); %los = %bot.getEyeVector(); %eye = %bot.getEyePoint(); %pos = %bot.getHackPosition();
	initContainerRadiusSearch(%pos, 7.5, $Typemasks::StaticShapeObjectType);
	while(isObject(%obj = containerSearchNext()))
	{
		if(!CastleDefense.isMember(%obj)) continue;
		if(%obj.isCastlePart && (!isObject(%castle) || vectorDist(%obj.getPosition(), "0 0 5") < 0.05)) %castle = %obj;
		if(%obj.maxHealth != 0 && (%obj.health < %obj.maxHealth || %bot.confused) && !isObject(%heal)) %heal = %obj;
	}
	if(!%bot.confused && isObject(%castle) && CastleDefense.health < CastleDefense.maxHealth)
	{
		%bot.setAimLocation(%castle.getPosition());
		if(vectorDist(%last, getSimTime()) >= 200)
		{
			%last = getSimTime();
			CastleDefense.health++;
			%bot.playThread(0, "activate");
			if(CastleDefense.health >= CastleDefense.maxHealth)
				CastleDefense.health = CastleDefense.maxHealth;
			if(!isEventPending(CastleDefense.updateSched))
				CastleDefense.updateSched = CastleDefense.schedule(200, "updateAll");
		}
	}
	else if(isObject(%heal))
	{
		%bot.setAimLocation(%heal.getPosition());
		if(vectorDist(%last, getSimTime()) >= 200)
		{
			%last = getSimTime(); %heal.health += (%bot.confused ? -1 : 1);
			%bot.playThread(0, "activate");
			if(%heal.health >= %heal.maxHealth)
				%heal.health = %heal.maxHealth;
			if(%heal.health < 0) %heal.delete();
			else
			{
				%col = %heal.health / (%heal.maxHealth * 2);
				%heal.setNodeColor("ALL", %hit.color = %col SPC %col SPC %col@" 1");
			}
		}
	}
	else	%bot.setAimVector(vectorNormalize(vectorSub(%pos, "0 0 "@getWord(%pos, 2))));
	%bot.AILoop = %bot.schedule(50, "MasonLoop", %last);
}

function AIPlayer::MedicLoop(%bot)
{
	if(%bot.getState() $= "DEAD") return; %bot.updatePos();
	if(CastleDefense.health <= 0) { %bot.dropEverything(); return; }
	cancel(%bot.AILoop); %los = %bot.getEyeVector(); %eye = %bot.getEyePoint(); %pos = %bot.getHackPosition();
	for(%i=0;%i<CastleDefense.getCount();%i++)
	{
		%obj = CastleDefense.getObject(%i);
		if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
		if(%obj.getState() $= "DEAD" || %obj.attacker) continue;
		if(vectorDist(%pos, %obj.getHackPosition()) > 7.5) continue;
		%obj.setDamageLevel(getMax(%obj.getDamageLevel() - 0.25, %obj.calcifiedDamage));
		if(%obj.calcifiedDamage > 0) %obj.calcifiedDamage -= (%obj.getClassName() $= "Player" ? 0.1 : 0.01); else %obj.calcifiedDamage = 0;
		if(isObject(%name = %obj.shapeName))
		{
			%damage = 1 - %obj.getDamagePercent();
			%name.setShapeName(mFloatLength(%damage * 100, 0));
			if(%damage >= 0.5) %name.setShapeNameColor(((1 - %damage) * 2)@" 1 0");
			else %name.setShapeNameColor("1 "@(%damage * 2)@" 0");
		}
	}
	if(!%bot.confused)
	{
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(!isObject(%obj = %cl.player) || %obj.attacker) continue; if(%obj.getState() $= "DEAD") continue;
			if(vectorDist(%pos, %obj.getHackPosition()) > 7.5) continue;
			%obj.setDamageLevel(%obj.getDamageLevel() - 0.25);
			CastleDefense.updateClient(%cl);
		}
	}
	%bot.AILoop = %bot.schedule(50, "MedicLoop");
}

function AIPlayer::WizardLoop(%bot)
{
	if(%bot.getState() $= "DEAD" || !isObject(%cl = %bot.client)) return; %bot.updatePos();
	if(CastleDefense.health <= 0) { %bot.dropEverything(); return; }
	cancel(%bot.AILoop); %los = %bot.getEyeVector(); %eye = %bot.getEyePoint(); %pos = %bot.getHackPosition();
	%mask = $Typemasks::StaticShapeObjectType;
	for(%i=0;%i<CastleDefense.getCount();%i++)
	{
		%obj = CastleDefense.getObject(%i);
		if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
		if(%obj.getState() $= "DEAD" || !%obj.attacker) continue;
		if(vectorDist(%pos, %obj.getHackPosition()) > 50) continue;
		if(isObject(containerRaycast(%pos, %obj.getHackPosition(), %mask, %bot, %obj))) continue;
		if(%obj.confused) %conf[-1+%conf++] = %obj;
		else %list[-1+%list++] = %obj;
	}
	if(%list == 0)
	{
		for(%i=0;%i<%conf;%i++)
			%list[%i] = %conf[%i];
		%list = %conf;
	}
	%bot.AILoop = %bot.schedule(50, "WizardLoop");
	if(%bot.confused) { %bot.setAimVector(getWords(vectorSub(%pos, "0 0"), 0, 1)); return; }
	if(!isEventPending(%cl.cantCast))
	{
		if(%bot.getDamageLevel() >= 50 && !isEventPending(%cl.cantCastHealSelf))
		{ CastHealSelf(%cl); return; }
		%least = "";
		for(%i=0;%i<%list;%i++)
		{
			if((%obj = %list[%i]).type !$= "Wizard") continue;
			if(vectorDist(%pos, %obj.getHackPosition()) > 20) continue;
			if((%dist = vectorDist(%pos, %obj.getHackPosition())) < %least || %least $= "")
			{ %least = %dist; %wizard = %obj; }
		}
		if(isObject(%wizard))
		{
		//	if(!isEventPending(%cl.cantCastFreeze) && !isEventPending(%wizard.unfreeze))   //No Freeze spell yet.
		//	{ CastFreeze(%cl, %wizard); return; }
			if(%wizard.isFrozen && !isEventPending(%cl.cantCastFireball))
			{ CastFireball(%cl, %wizard); return; }
			if(!isEventPending(%cl.cantCastChainLightning))
			{
				for(%i=0;%i<%list;%i++)
				{
					if((%obj = %list[%i]) == %wizard) continue;
					if(vectorDist(%pos, %obj.getHackPosition()) <= 15)
					{
						%dir = vectorNormalize(vectorSub(%wizard.getHackPosition(), %pos));
						if(vectorDot(%dir, %los) >= 0.999) CastChainLightning(%cl, %wizard);
						else %bot.setAimVector(%dir);
						return;
					}
				}
			}
		}
		if(!isEventPending(%cl.cantCastConfusion))
		{
			%least = "";
			for(%i=0;%i<%list;%i++)
			{
				%obj = %list[%i]; if(%obj.confused || %obj.getClassName() $= "Player") continue;
				if(vectorDist(%pos, %obj.getHackPosition()) > 20) continue;
				if((%dist = vectorDist(%pos, %obj.getHackPosition())) < %least || %least $= "")
				{ %least = %dist; %targ = %obj; }
			}
			if(isObject(%targ))
			{
				%dir = vectorNormalize(vectorSub(%targ.getHackPosition(), %pos));
				if(vectorDot(%dir, %los) >= 0.999) CastConfusion(%cl, %targ);
				else %bot.setAimVector(%dir);
				return;
			}
		}
		if(!isObject(%wizard) && !isEventPending(%cl.cantCastChainLightning))
		{
			%least = "";
			for(%i=0;%i<%list;%i++)
			{
				%nearby = 0;
				%obj = %list[%i];
				if(vectorDist(%pos, %obj.getHackPosition()) > 20) continue;
				for(%j=0;%j<%list;%j++)
				{
					if(%i == %j) continue;
					%test = %list[%j];
					if(vectorDist(%obj.getHackPosition(), %test.getHackPosition()) <= 15)
						%nearby++;
				}
				%dist = vectorDist(%pos, %obj.getHackPosition());
				if(%nearby > %greatest) { %greatest = %nearby; %targ = %obj; %least = %dist; }
				else if(%nearby == %greatest && (%dist < %least || %least $= ""))
				{ %greatest = %nearby; %targ = %obj; %least = %dist; }
			}
			if(isObject(%targ) && %greatest >= 3)
			{
				%dir = vectorNormalize(vectorSub(%targ.getHackPosition(), %pos));
				if(vectorDot(%dir, %los) >= 0.999) CastChainLightning(%cl, %targ);
				else %bot.setAimVector(%dir);
				return;
			}
		}
		%targ = ""; %greatest = "";
		for(%i=0;%i<CastleDefense.getCount();%i++)
		{
			%obj = CastleDefense.getObject(%i); if(%bot == %obj) continue;
			if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
			if(%obj.getState() $= "DEAD" || %obj.attacker) continue;
			if(vectorDist(%pos, %obj.getHackPosition()) > 20) continue;
			if(isObject(containerRaycast(%pos, %obj.getHackPosition(), %mask, %bot, %obj))) continue;
			if(%obj.getDamageLevel() > %greatest) { %targ = %obj; %greatest = %obj.getDamageLevel(); }
		}
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			if(!isObject(%obj = ClientGroup.getObject(%i).player)) continue;
			if(%obj.getState() $= "DEAD" || %obj.attacker) continue;
			if(vectorDist(%pos, %obj.getHackPosition()) > 20) continue;
			if(isObject(containerRaycast(%pos, %obj.getHackPosition(), %mask, %bot, %obj))) continue;
			if(%obj.getDamageLevel() > %greatest) { %targ = %obj; %greatest = %obj.getDamageLevel(); }
		}
		if(isObject(%targ))
		{
			%dir = vectorNormalize(vectorSub(%targ.getHackPosition(), %pos));
			if(vectorDot(%dir, %los) >= 0.999) CastHealOther(%cl, %targ);
			else %bot.setAimVector(%dir);
			return;
		}
		if(!isObject(%wizard) && !isEventPending(%cl.cantCastFireball))
		{
			%least = ""; %greatest = "";
			for(%i=0;%i<%list;%i++)
			{
				%nearby = 0;
				%obj = %list[%i];
				if(vectorDist(%pos, %obj.getHackPosition()) > 20) continue;
				for(%j=0;%j<%list;%j++)
				{
					if(%i == %j) continue;
					%test = %list[%j];
					if(vectorDist(%obj.getHackPosition(), %test.getHackPosition()) <= 5) %nearby++;
				}
				for(%j=0;%j<CastleDefense.getCount();%j++)
				{
					%test = CastleDefense.getObject(%j);
					if(!(%test.getType() & $Typemasks::PlayerObjectType)) continue;
					if(%test.getState() $= "DEAD" || %test.attacker) continue;
					if(vectorDist(%obj.getHackPosition(), %test.getHackPosition()) <= 5) %nearby--;
				}
				for(%j=0;%j<ClientGroup.getCount();%j++)
				{
					if(!isObject(%test = ClientGroup.getObject(%j).player)) continue;
					if(%test.getState() $= "DEAD" || %test.attacker) continue;
					if(vectorDist(%obj.getHackPosition(), %test.getHackPosition()) <= 5) %nearby--;
				}
				%dist = vectorDist(%pos, %obj.getHackPosition());
				if(%nearby > %greatest || %greatest $= "") { %greatest = %nearby; %targ = %obj; %least = %dist; }
				else if(%nearby == %greatest && (%dist < %least || %least $= ""))
				{ %greatest = %nearby; %targ = %obj; %least = %dist; }
			}
			if(isObject(%targ))
			{
				%dir = vectorNormalize(vectorSub(%targ.getHackPosition(), %pos));
				if(vectorDot(%dir, %los) >= 0.999) CastFireball(%cl, %targ);
//					if(%greatest > 0) CastFireball(%cl, %targ);
//					else CastChainLightning(%cl, %targ);
				else %bot.setAimVector(%dir);
				return;
			}
		}
		%bot.setAimVector(getWords(vectorSub(%pos, "0 0"), 0, 1));
	}
}

// .___________________________________________.
// | .____ .   . .____ .   . _____ .____  ___  |
// | |     |\  | |     |\ /|   |   |     /   \ |
// | |__   | \ | |__   | V |   |   |__   \___  |
// | |     |  \| |     |   |   |   |         \ |
// | |____ |   | |____ |   | __|__ |____ \___/ |
// |___________________________________________|

function AIPlayer::AtkArcherLoop(%bot)
{
	if(%bot.getState() $= "DEAD") return;
	if(CastleDefense.health <= 0) { %bot.dropEverything(); return; }
	cancel(%bot.AILoop); %los = %bot.getEyeVector(); %eye = %bot.getEyePoint(); %pos = %bot.getHackPosition();
	if(getMax(mAbs(getWord(%pos, 0)), mAbs(getWord(%pos, 1))) > 110) { %bot.kill(); return; }
	if(!isObject(%bot.getMountedImage(0))) { %bot.mountImage(BowImage, 0); fixArmReady(%bot); }
	%mask = $Typemasks::StaticShapeObjectType;
	if(%bot.confused)
	{
		for(%i=0;%i<CastleDefense.getCount();%i++)
		{
			%obj = CastleDefense.getObject(%i); if(%obj == %bot) continue;
			if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
			if(%obj.getState() $= "DEAD" || !%obj.attacker || %obj.confused) continue;
			if(vectorDot(vectorNormalize(vectorSub(%obj.getHackPosition(), %pos)), %los) < 0.25) continue;
			%list[-1+%list++] = %obj;
		}
	}
	else
	{
		for(%i=0;%i<CastleDefense.getCount();%i++)
		{
			%obj = CastleDefense.getObject(%i); if(%obj == %bot) continue;
			if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
			if(%obj.getState() $= "DEAD" || !(!%obj.attacker && !%obj.confused)) continue;
			if(vectorDot(vectorNormalize(vectorSub(%obj.getHackPosition(), %pos)), %los) < 0.25) continue;
			%list[-1+%list++] = %obj;
		}
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(%cl.isInvisible) continue;
			if(!isObject(%obj = %cl.player) || !(!%obj.attacker && !%obj.confused)) continue; if(%obj.getState() $= "DEAD") continue;
			if(vectorDot(vectorNormalize(vectorSub(%obj.getHackPosition(), %pos)), %los) < 0.25) continue;
			%list[-1+%list++] = %obj;
		}
	}
	while(!isObject(%targ) && %list != 0)
	{
		%least = ""; %shift = 0;
		for(%i=0;%i<%list;%i++)
		{
			if((%dist = vectorDist(%pos, %list[%i].getHackPosition())) < %least || %least $= "")
			{ %least = %dist; %targ = %list[%i]; }
		}
		if(!isObject(%targ)) break;
		if(isObject(containerRaycast(%bot.getMuzzlePoint(0), %targ.getEyePoint(), %mask, %bot, %targ)) ||
			(isObject(containerRaycast(%eye, %targ.getHackPosition(), %mask, %bot, %targ)) && isObject(containerRaycast(%eye, %targ.getEyePoint(), %mask, %bot, %targ))))
		{
			for(%i=0;%i<%list;%i++)
				if(%list[%i] == %targ) %shift++;
				else %list[%i - %shift] = %list[%i];
			%list -= %shift; %targ = "";
		}
	}
	%bot.setImageTrigger(0, 1);
	if(isObject(%targ))
	{
		%bot.setAimVector(getFireVector(ArrowProjectile, %bot, %targ));
		%bot.setMoveY(0); %bot.setMoveX(0);
	}
	else
	{
		%bot.setAimVector(getFireAimVector(%bot.getMuzzlePoint(0), "0 0 7.5", ArrowProjectile.gravityMod * 10, ArrowProjectile.muzzleVelocity));
		if(vectorDist("0 0", getWords(%bot.getPosition(), 0, 1)) <= 25) { %bot.setMoveY(-10); %bot.setMoveX(0); }
		else if(vectorDist("0 0", getWords(%bot.getPosition(), 0, 1)) >= 35)
		{
			%bot.setMoveY(10);
			%left = vectorCross(%bot.getUpVector(), %bot.getForwardVector());
			%leftPos = vectorAdd(%bot.getPosition(), %left); %rightPos = vectorAdd(%bot.getPosition(), vectorScale(%left, -1));
			%leftHit = containerRaycast(%leftPos, vectorAdd(%leftPos, vectorScale(%bot.getForwardVector(), 20)), $Typemasks::StaticShapeObjectType);
			%rightHit = containerRaycast(%rightPos, vectorAdd(%rightPos, vectorScale(%bot.getForwardVector(), 20)), $Typemasks::StaticShapeObjectType);
			if(!isObject(%leftHit) || %leftHit.isCastlePart) %leftDist = 20;
			else %leftDist = vectorDist(getWords(%leftHit, 1, 3), %leftPos);
			if(!isObject(%rightHit) || %rightHit.isCastlePart) %rightDist = 20;
			else %rightDist = vectorDist(getWords(%rightHit, 1, 3), %rightPos);
			initContainerRadiusSearch(%leftPos, 0.05, $Typemasks::StaticShapeObjectType); if(isObject(containerSearchNext())) %leftDist = 0;
			initContainerRadiusSearch(%rightPos, 0.05, $Typemasks::StaticShapeObjectType); if(isObject(containerSearchNext())) %rightDist = 0;
			if(vectorDist(%leftDist, %rightDist) <= 0.5) %bot.setMoveX(0);
			else if(%leftDist > %rightDist) %bot.setMoveX(-10);
			else if(%leftDist < %rightDist) %bot.setMoveX(10);
			else %bot.setMoveX(0);
		}
		else { %bot.setMoveY(0); %bot.setMoveX(0); }
	}
	%bot.AILoop = %bot.schedule(50, "AtkArcherLoop");
}

function AIPlayer::AtkBasicLoop(%bot, %hangTime, %hangDir)
{
	if(%bot.getState() $= "DEAD") return;
	if(CastleDefense.health <= 0) { %bot.dropEverything(); return; }
	cancel(%bot.AILoop); %los = %bot.getEyeVector(); %eye = %bot.getEyePoint(); %pos = %bot.getHackPosition();
	if(getMax(mAbs(getWord(%pos, 0)), mAbs(getWord(%pos, 1))) > 110) { %bot.kill(); return; }
	if(!isObject(%bot.getMountedImage(0))) { %bot.mountImage(SwordImage, 0); fixArmReady(%bot); }
	%mask = $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType;
	if(%bot.confused)
	{
		for(%i=0;%i<CastleDefense.getCount();%i++)
		{
			%obj = CastleDefense.getObject(%i); if(%obj == %bot) continue;
			if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
			if(%obj.getState() $= "DEAD" || !%obj.attacker) continue;
			if(vectorDot(vectorNormalize(vectorSub(%obj.getHackPosition(), %pos)), %los) < 0.25) continue;
			%list[-1+%list++] = %obj;
		}
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(!isObject(%obj = %cl.player) || !%obj.attacker) continue; if(%obj.getState() $= "DEAD") continue;
			if(vectorDot(vectorNormalize(vectorSub(%obj.getHackPosition(), %pos)), %los) < 0.25) continue;
			%list[-1+%list++] = %obj;
		}
		while(!isObject(%targ) && %list != 0)
		{
			%least = ""; %shift = 0;
			for(%i=0;%i<%list;%i++)
			{
				if((%dist = vectorDist(%pos, %list[%i].getHackPosition())) < %least || %least $= "")
				{ %least = %dist; %targ = %list[%i]; }
			}
			if(!isObject(%targ)) break;
			if(isObject(containerRaycast(%bot.getMuzzlePoint(0), %targ.getEyePoint(), %mask, %bot, %targ)) ||
				(isObject(containerRaycast(%eye, %targ.getHackPosition(), %mask, %bot, %targ)) && isObject(containerRaycast(%eye, %targ.getEyePoint(), %mask, %bot, %targ))))
			{
				for(%i=0;%i<%list;%i++)
					if(%list[%i] == %targ) %shift++;
					else %list[%i - %shift] = %list[%i];
				%list -= %shift; %targ = "";
			}
		}
		if(isObject(%targ))
		{
			%bot.setAimLocation(%targ.getHackPosition());
			if(%least <= 4) %bot.setImageTrigger(0, 1);
			else %bot.setImageTrigger(0, 0);
			%bot.setMoveY(10);
		}
		else
		{
			%bot.setMoveY(0);
			%bot.setAimVector(%los);
			%bot.setImageTrigger(0, 0);
		}
	}
	else
	{
		if(%hangDir !$= "")
		{
			%bot.setAimVector(%hangDir);
			%hangTime++; %aiming = 1;
			if(%hangTime >= 30)
			{ %hangTime = 0; %hangDir = ""; }
		}
		else
		{
			%ray = containerRaycast(%bot.getPosition(), vectorAdd(%bot.getPosition(), vectorScale(%bot.getForwardVector(), 2)), $Typemasks::StaticShapeObjectType);
			if(isObject(%obj = firstWord(%ray)))
			{
				if(getWord(%obj.getScale(), 2) == 1)
				{
					initContainerBoxSearch(vectorAdd(%obj.getPosition(), "0 0 2"), "0.05 0.05 0.05", $Typemasks::StaticShapeObjectType);
					if(isObject(%obs = containerSearchNext()))
					{
						if(%obs.getScale() $= "1 1 1")
						{ %aiming = 1; %bot.setAimLocation(%obs.getPosition()); %bot.setImageTrigger(0, 1); %bot.setMoveY(0); %noHang = 1; }
					}
					else { %bot.setImageTrigger(0, 0); %bot.setMoveY(10); %jump = 1; }
				}
				else
				{
					if(%obj.isCastlePart) { %bot.setImageTrigger(0, 1); %noHang = 1; }
					else %bot.setImageTrigger(0, 0);
					%bot.setMoveY(10);
				}
			}
			else
			{
				%ray = containerRaycast(%start = vectorAdd(%bot.getPosition(), "0 0 2"), vectorAdd(%start, vectorScale(%bot.getForwardVector(), 2)), $Typemasks::StaticShapeObjectType);
				if(isObject(%obj = firstWord(%ray)) && %obj.getScale() $= "1 1 1") %crouch = 1;
				%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%los, 5)), %mask, %bot);
				if(isObject(%obj = firstWord(%ray)))
				{
					if((%obj.getType() & $Typemasks::PlayerObjectType) && !%obj.attacker) { %bot.setImageTrigger(0, 1); %noHang = 1; }
					else if(%obj.isCastlePart) { %bot.setImageTrigger(0, 1); %noHang = 1; } else %bot.setImageTrigger(0, 0);
				}
				else %bot.setImageTrigger(0, 0);
				%bot.setMoveY(10);
			}
		}
		if(%hangDir !$= "") { }
		else if(%noHang || vectorLen(%bot.getVelocity()) > 0.05)
			%hangTime = 0;
		else
		{
			%hangTime++;
			if(%hangTime >= 20)
			{
				%pi = 3.14159265;
				%dir = vectorSub(%pos, "0 0 0"); %dir = mAtan(getWord(%dir, 0), getWord(%dir, 1));
				%dir += getRandom(100, -100) / 100; if(%dir <= -%pi) %dir += 2 * %pi; if(%dir >= %pi) %dir -= 2 * %pi;
				%hangDir = mSin(%dir) SPC mCos(%dir); %hangTime = 0;
			}
		}
		%left = vectorCross(%bot.getUpVector(), %bot.getForwardVector());
		%leftPos = vectorAdd(%bot.getPosition(), %left); %rightPos = vectorAdd(%bot.getPosition(), vectorScale(%left, -1));
		%leftHit = containerRaycast(%leftPos, vectorAdd(%leftPos, vectorScale(%bot.getForwardVector(), 20)), $Typemasks::StaticShapeObjectType);
		%rightHit = containerRaycast(%rightPos, vectorAdd(%rightPos, vectorScale(%bot.getForwardVector(), 20)), $Typemasks::StaticShapeObjectType);
		if(!isObject(%leftHit) || %leftHit.isCastlePart) %leftDist = 20;
		else %leftDist = vectorDist(getWords(%leftHit, 1, 3), %leftPos);
		if(!isObject(%rightHit) || %rightHit.isCastlePart) %rightDist = 20;
		else %rightDist = vectorDist(getWords(%rightHit, 1, 3), %rightPos);
		initContainerRadiusSearch(%leftPos, 0.05, $Typemasks::StaticShapeObjectType); if(isObject(containerSearchNext())) %leftDist = 0;
		initContainerRadiusSearch(%rightPos, 0.05, $Typemasks::StaticShapeObjectType); if(isObject(containerSearchNext())) %rightDist = 0;
		if(vectorDist(%leftDist, %rightDist) <= 0.5) %bot.setMoveX(0);
		else if(%leftDist > %rightDist) %bot.setMoveX(-10);
		else if(%leftDist < %rightDist) %bot.setMoveX(10);
		else %bot.setMoveX(0);
		%bot.setJumping(!!%jump); %bot.setCrouching(!!%crouch);
		if(!%aiming) %bot.setAimLocation("0 0 "@getMin(getWord(%pos, 2), 5));
	}
	%bot.AILoop = %bot.schedule(50, "AtkBasicLoop", %hangTime, %hangDir);
}

function AIPlayer::AtkKnightLoop(%bot)
{
	if(%bot.getState() $= "DEAD") return;
	if(CastleDefense.health <= 0) { %bot.dropEverything(); return; }
	cancel(%bot.AILoop); %los = %bot.getEyeVector(); %eye = %bot.getEyePoint(); %pos = %bot.getHackPosition();
	if(getMax(mAbs(getWord(%pos, 0)), mAbs(getWord(%pos, 1))) > 110) { %bot.kill(); return; }
	%mount = %bot.getObjectMount(); %mask = $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType;
	for(%i=0;%i<%bot.damagers;%i++)
	{
		%cl = %bot.damager[%i];
		%damage = (%bot.damageFrom[%cl] *= 0.99);
		if(%damage >= 5 && isObject(%cl.player)) %list[-1+%list++] = %cl;
	}
	while(!isObject(%targ) && %list != 0)
	{
		%least = ""; %shift = 0;
		for(%i=0;%i<%list;%i++)
		{
			%dmg = %bot.damageFrom[%cl = %list[%i]];
			if(%dmg > %aggro || %aggro $= "")
			{ %aggro = %dmg; %targ = %cl.player; }
		}
		if(!isObject(%targ)) break;
		if(vectorDist(%pos, %targ.getHackPosition()) >= 5 && (isObject(containerRaycast(%bot.getMuzzlePoint(0), %targ.getEyePoint(), %mask, %bot, %targ, %mount)) ||
			(isObject(containerRaycast(%eye, %targ.getHackPosition(), %mask, %bot, %targ, %mount)) && isObject(containerRaycast(%eye, %targ.getEyePoint(), %mask, %bot, %targ, %mount)))))
		{
			for(%i=0;%i<%list;%i++)
				if(%list[%i] == %targ) %shift++;
				else %list[%i - %shift] = %list[%i];
			%list -= %shift; %targ = "";
		}
	}
	if(isObject(%targ))
	{
		%dist = vectorDist(%pos, %targ.getHackPosition());
		if(!isObject(%image = %bot.getMountedImage(0))) { %bot.mountImage(%dist > 25 ? BowImage : SwordImage, 0); fixArmReady(%bot); }
		else if(%image.getID() == SpearImage.getID() && %bot.getImageState(0) $= "Ready") { %bot.mountImage(%dist > 7.5 ? BowImage : SwordImage, 0); fixArmReady(%bot); }
		else if(%image.getID() == SwordImage.getID() && %dist > 25) { %bot.mountImage(BowImage, 0); fixArmReady(%bot); }
		else if(%image.getID() == BowImage.getID() && %dist <= 25) { %bot.mountImage(SwordImage, 0); fixArmReady(%bot); }
		%image = %bot.getMountedImage(0);
		if(%image.getID() == BowImage.getID())
		{
			%bot.setAimVector(getFireVector(ArrowProjectile, %bot, %targ));
			%bot.setImageTrigger(0, 1);
		}
		else if(%image.getID() == SwordImage.getID())
		{
			%bot.setAimLocation(%targ.getHackPosition());
			%bot.setImageTrigger(0, 1); if(%dist >= 3) %moveY = 20;
		}
		else if(%image.getID() == SpearImage.getID())
		{
			%bot.setAimVector(%fireDir = getFireVector(SpearProjectile, %bot, %targ));
			if(%bot.getImageState(0) !$= "Armed") %bot.setImageTrigger(0, 1);
			else if(vectorDot(%bot.getMuzzleVector(0), %fireDir) < 0.9999) %bot.setImageTrigger(0, 1);
			else { %bot.setImageTrigger(0, 0); %bot.mountImage(%dist > 7.5 ? BowImage : SwordImage, 0); fixArmReady(%bot); }
		}
	}
	else if(%list != 0)
		%bot.setImageTrigger(0, 0);
	else
	{
		//Add a block-targetting AI for when the Knight has no living target
		//%least = 
		if(!isObject(%image = %bot.getMountedImage(0)) || %image.getID() != SpearImage.getID()) { %bot.mountImage("SpearImage", 0); fixArmReady(%bot); }
		%bot.setImageTrigger(0, 1);
	}
	%bot.setMoveY(%moveY + 0);
	%bot.AILoop = %bot.schedule(50, "AtkKnightLoop");
}

function AIPlayer::dropEverything(%bot)
{
	if(isObject(%name = %bot.shapeName)) %name.delete();
	%bot.setCrouching(0); %bot.setJumping(0); %bot.setImageTrigger(0, 0); %bot.setMoveX(0); %bot.setMoveY(0);
}
function AIPlayer::updatePos(%bot)
{
	%horizMoved = getWords(%bot.getPosition(), 0, 1) !$= getWords(%bot.origPos, 0, 1);
	%vertMoved = getWord(%bot.getPosition(), 2) < getWord(%bot.origPos, 2) - 4;
	if(%horizMoved || %vertMoved)
	{
		%finalTransform = %bot.getTransform();
		if(%horizMoved) %finalTransform = setWord(setWord(%finalTransform, 0, getWord(%bot.origPos, 0)), 1, getWord(%bot.origPos, 1));
		//if(%vertMoved) %finalTransform = setWord(%finalTransform, 2, getWord(%bot.origPos, 2));
		%bot.setTransform(%finalTransform);
	}
	%bot.setVelocity("0 0 "@getWord(%bot.getVelocity(), 2));
	if(!isObject(%name = %bot.shapeName)) return;
	if(%name.currPos !$= (%pos = %bot.getPosition()))
	{
		%bot.shapeName.setTransform(vectorAdd(%pos, "0 0 2.12")@" 1 0 0 0");
		%name.currPos = %pos;
	}
}
