package CastleDefense_Builder
{
	function Armor::onTrigger(%data, %this, %trig, %tog)
	{
		if(%this.canBuild)
		{
			if(%trig == 0 && %tog && !isObject(%this.getMountedImage(0)))
			{
				if(%this.isBuilding)
				{
					if((%cube = %this.targetCube).canPlant)
					{
						if(CastleDefense.score >= 5)
						{
							%cube.canPlant = 0;
							(%shape = new StaticShape()
							{
								builtCube = 1; color = %this.currColor@" 1";
								datablock = CastleDefenseCube_Col1;
								position = %cube.currPos;
								health = 20; maxHealth = 20;
							}).setNodeColor("ALL", %this.currColor@" 1");
							CastleDefense.add(%shape);
							CastleDefense.score -= 5;
							CastleDefense.updateAll();
						}
					}
				}
				else
				{
					%mask = $Typemasks::fxBrickObjectType | $Typemasks::StaticShapeObjectType | $Typemasks::TerrainObjectType;
					if(isObject(%ray = containerRaycast(%eye = %this.getEyePoint(), vectorAdd(%eye, vectorScale(%this.getEyeVector(), 20)), %mask)))
					{
						%obj = firstWord(%ray);
						if(%obj.builtCube)
						{
							if(%obj.health >= %obj.maxHealth)
							{
								%obj.delete();
								CastleDefense.score += 5;
								CastleDefense.updateAll();
							}
							else %this.client.centerPrint("<br><br><br><br><br><br><br><color:FF8000>Whoops!<color:FFFFFF> You can only reclaim blocks that are at full health!", 3);
						}
					}
				}
				return;
			}
			if(%trig == 4 && %tog)
			{
				if(%this.isBuilding) { if(isObject(%cube = %this.targetCube)) %cube.delete(); %this.isBuilding = 0; }
				else
				{
					%cube = new StaticShape() { datablock = CastleDefenseIndicator_2x2x2; };
					%cube.setNodeColor("ALL", "1 0 0 1");
					%this.targetLoop(%cube);
					%this.isBuilding = 1;
				}
				return;
			}
		}
		else if(%this.placingBot !$= "")
		{
			if(isEventPending(%this.cantPlaceBots)) return;
			%this.cantPlaceBots = schedule(200, 0, "doNothing");
			if(%trig == 0 && %tog && !isObject(%this.getMountedImage(0)))
			{
				%cost = CD_UnitCost(%this.placingBot, 0);
				if(%cost == -1 || CastleDefense.score < %cost) return;
				if(!(%cube = %this.targetCube).canPlant) return; %cube.canPlant = 0; %cube.setNodeColor("ALL", "1 0 0 1");
				%bot = new AIPlayer() { datablock = PlayerNoJet; position = "0 0 -999"; type = %this.placingBot; };
				%diff = vectorSub(%pos = %this.targetCube.currPos, "0 0 "@getWord(%pos, 2));
				%pi = 3.14159265; %ang = mAtan(getWord(%diff, 0), getWord(%diff, 1));
				%bot.setTransform(vectorAdd(%pos, "0 0 -1.975")@" 0 0 1 "@%ang);
				%skin = mSqrt(getRandom(16, 64) / 100); %skin = %skin SPC (%skin - 0.2) SPC (%skin - 0.4);
				%bot.setNodeColor("headskin", %skin@" 1.0");
				%bot.setNodeColor("lhand", %skin@" 1.0");
				%bot.setNodeColor("rhand", %skin@" 1.0");
				%bot.origPos = %this.targetCube.currPos;
				switch$(%this.placingBot)
				{
					case "Archer":
						%bot.unhideNode("scoutHat");
						%bot.unhideNode("quiver");
						%bot.setNodeColor("scoutHat", "0.1 0.6 0.2 1.0");
						%bot.setNodeColor("chest", "0.0 0.5 0.0 1.0");
						%bot.setNodeColor("quiver", "0.5 0.3 0.1 1.0");
						%bot.setNodeColor("larm", "0.0 0.4 0.0 1.0");
						%bot.setNodeColor("rarm", "0.0 0.4 0.0 1.0");
						%bot.setNodeColor("lhand", "0.3 0.3 0.3 1.0");
						%bot.setNodeColor("rhand", "0.3 0.3 0.3 1.0");
						%bot.setNodeColor("pants", "0.2 0.2 0.2 1.0");
						%bot.setNodeColor("lshoe", "0.2 0.2 0.2 1.0");
						%bot.setNodeColor("rshoe", "0.2 0.2 0.2 1.0");
						%bot.setDecalName("Archer");
						%bot.playThread(0, "headUp");
						%bot.ArcherLoop();
						%name = "Archer";
					case "Knight":
					//	%bot.logAttacks = 1;
						%bot.unhideNode("pointyHelmet");
						%bot.unhideNode("shoulderPads");
						%bot.unhideNode("armor");
						%bot.setNodeColor("pointyHelmet", "0.3 0.3 0.3 1.0");
						%bot.setNodeColor("shoulderPads", "0.3 0.3 0.3 1.0");
						%bot.setNodeColor("chest", "0.2 0.2 0.2 1.0");
						%bot.setNodeColor("larm", "0.2 0.2 0.2 1.0");
						%bot.setNodeColor("rarm", "0.2 0.2 0.2 1.0");
						%bot.setNodeColor("armor", "0.3 0.3 0.3 1.0");
						%bot.setNodeColor("pants", "0.2 0.2 0.2 1.0");
						%bot.setNodeColor("lshoe", "0.2 0.2 0.2 1.0");
						%bot.setNodeColor("rshoe", "0.2 0.2 0.2 1.0");
						%bot.playThread(0, "headUp");
						%bot.KnightLoop();
						%name = "Knight";
					case "Mason":
						%bot.unhideNode("scoutHat");
						%bot.unhideNode("pack");
						%bot.setNodeColor("scoutHat", "0.3 0.3 0.3 1.0");
						%bot.setNodeColor("chest", "0.3 0.3 0.3 1.0");
						%bot.setNodeColor("pack", "0.5 0.3 0.1 1.0");
						%bot.setNodeColor("larm", "0.2 0.2 0.2 1.0");
						%bot.setNodeColor("rarm", "0.2 0.2 0.2 1.0");
						%bot.setNodeColor("pants", "0.3 0.3 0.3 1.0");
						%bot.setNodeColor("lshoe", "0.2 0.2 0.2 1.0");
						%bot.setNodeColor("rshoe", "0.2 0.2 0.2 1.0");
						%bot.setDecalName("Alyx");
						%bot.playThread(0, "headUp");
						%bot.MasonLoop();
						%name = "Mason";
					case "Medic":
						%bot.unhideNode("scoutHat");
						%bot.unhideNode("pack");
						%bot.setNodeColor("scoutHat", "0.6 0.6 0.6 1.0");
						%bot.setNodeColor("chest", "0.8 0.8 0.8 1.0");
						%bot.setNodeColor("pack", "0.5 0.3 0.1 1.0");
						%bot.setNodeColor("larm", "0.7 0.7 0.7 1.0");
						%bot.setNodeColor("rarm", "0.7 0.7 0.7 1.0");
						%bot.setNodeColor("pants", "0.5 0.5 0.5 1.0");
						%bot.setNodeColor("lshoe", "0.3 0.3 0.3 1.0");
						%bot.setNodeColor("rshoe", "0.3 0.3 0.3 1.0");
						%bot.setDecalName("LinkTunic");
						%bot.playThread(0, "headUp");
						%bot.MedicLoop();
						%name = "Medic";
					case "Wizard":
						%bot.unhideNode("scoutHat");
						%bot.unhideNode("cape");
						%bot.setNodeColor("scoutHat", "0.0 0.0 0.2 1.0");
						%bot.setNodeColor("chest", "0.1 0.1 0.3 1.0");
						%bot.setNodeColor("larm", "0.0 0.0 0.2 1.0");
						%bot.setNodeColor("rarm", "0.0 0.0 0.2 1.0");
						%bot.setNodeColor("cape", "0.0 0.0 0.0 1.0");
						%bot.setNodeColor("pants", "0.0 0.0 0.1 1.0");
						%bot.setNodeColor("lshoe", "0.1 0.1 0.1 1.0");
						%bot.setNodeColor("rshoe", "0.1 0.1 0.1 1.0");
						%bot.playThread(0, "headUp");
						%bot.schedule(50, "WizardLoop");
						%name = "Wizard";
				}
				%bot.shapeName = new StaticShape() { currPos = %bot.getPosition(); datablock = EmptyShape; };
				%bot.shapeName.setTransform(vectorAdd(%bot.getPosition(), "0 0 2.12")@" 1 0 0 0");
				%bot.shapeName.setShapeName("100"); %bot.shapeName.setShapeNameColor("0 1 0");
				if(CastleDefense.idleClients <= 0)
				{ %bot.client = new AIConnection() { botName = %name; player = %bot; }; $Clients++; }
				else
				{
					%cl = CastleDefense.idleClient[CastleDefense.idleClients--];
					%bot.client = %cl; %cl.attacker = 0; %cl.botName = %name; %cl.player = %bot;
				}
				CastleDefense.add(%bot); CastleDefense.add(%bot.shapeName); CastleDefense.score -= %cost; CastleDefense.updateAll();
				return;
			}
			else if(%trig == 4 && %tog)
			{
				initContainerBoxSearch(%pos = %this.targetCube.currPos, "1.95 1.95 3.95", $Typemasks::PlayerObjectType);
				while(isObject(%obj = containerSearchNext()))
				{
					if(%obj.getClassName() $= "AIPlayer")
					{
						%loc = %obj.getHackPosition();
						%x = mFloatLength((getWord(%loc, 0) - 1) / 2, 0) * 2 + 1;
						%y = mFloatLength((getWord(%loc, 1) - 1) / 2, 0) * 2 + 1;
						%z = mFloatLength((getWord(%loc, 2) - 1) / 2, 0) * 2 + 2;
						%loc = %x SPC %y SPC %z;
						if(vectorDist(%loc, %pos) <= 0.05) %targ = %obj;
					}
				}
				if(isObject(%targ))
				{
					if(CD_UnitCost(%targ.type) != 0)
					{
						if(%targ.getDamagePercent() == 0 && !%targ.confused)
						{
							(%this = %targ.client).player = ""; %targ.client = "";
							CastleDefense.idleClient[-1+CastleDefense.idleClients++] = %this;
							CastleDefense.score += CD_UnitCost(%targ.type, -1); CastleDefense.updateAll(); %targ.delete();
						}
						else if(%targ.confused) %cl.centerPrint("<br><br><br><br><br><br><br><color:FF8000>Whoops!<color:FFFFFF> That unit is \c5Confused<color:FFFFFF> and will not let you remove him!", 3);
						else %cl.centerPrint("<br><br><br><br><br><br><br><color:FF8000>Whoops!<color:FFFFFF> Can only delete units that are fully healed!", 3);
						return;
					}
				}
			}
		}
		Parent::onTrigger(%data, %this, %trig, %tog);
	}
	
	function servercmdUseInventory(%cl, %inv)
	{
		if(!isObject(CastleDefense)) Parent::servercmdUseInventory(%cl, %inv);
		else if(%cl != $Builder || !isObject(%pl = %cl.player)) return;
		else if(%inv == %cl.currInvSlot) return;
		if(!isObject(%cube = %pl.targetCube))
		{
			%cube = new StaticShape() { datablock = CastleDefenseIndicator_2x2x2; };
			%cube.setNodeColor("ALL", "1 0 0 1");
			%pl.targetLoop(%cube);
			%cl.currInvSlot = 9;
		}
		if(%inv == 9)
		{
			%cube.setDatablock(CastleDefenseIndicator_2x2x2);
			%cube.setNodeColor("ALL", "1 0 0 1");
			%cube.canPlant = 0;
			%pl.targetLoop(%cube);
		}
		else if(%cl.currInvSlot == 9)
		{
			%cube.setDatablock(CastleDefenseIndicator_2x2x4);
			%cube.setNodeColor("ALL", "1 0 0 1");
			%cube.canPlant = 0;
			%pl.targetLoopBot(%cube);
		}
		%cl.currInvSlot = %inv;
		messageClient(%cl, 'MsgSetInvData', '', 0, brickArcherIconData.getID());
		messageClient(%cl, 'MsgSetInvData', '', 1, brickMasonIconData.getID());
		messageClient(%cl, 'MsgSetInvData', '', 2, brickMedicIconData.getID());
		messageClient(%cl, 'MsgSetInvData', '', 3, CastleDefense.level <= 10 ? 0 : brickKnightIconData.getID());
		messageClient(%cl, 'MsgSetInvData', '', 4, CastleDefense.level <= 20 ? 0 : brickWizardIconData.getID());   //Clearly wrong.
		messageClient(%cl, 'MsgSetInvData', '', 5, 0);
		messageClient(%cl, 'MsgSetInvData', '', 6, 0);
		messageClient(%cl, 'MsgSetInvData', '', 7, 0);
		messageClient(%cl, 'MsgSetInvData', '', 8, 0);
		messageClient(%cl, 'MsgSetInvData', '', 9, brickBuildingIconData.getID());
		%pl.canBuild = 0;
		switch$(%inv)
		{
			case 0: %pl.placingBot = "Archer";
			case 1: %pl.placingBot = "Mason";
			case 2: %pl.placingBot = "Medic";
			case 3: if(CastleDefense.level > 10) %pl.placingBot = "Knight";
			case 4: if(CastleDefense.level > 10) %pl.placingBot = "Wizard";
			case 9:
				%pl.placingBot = "";
				if(!%pl.canBuild)
				{
					%pl.canBuild = 1;
					%pl.currColor = "0.5 0.5 0.5";
				}
				return;
			default: return;
		}
		CastleDefense.updateClient(%cl);
		//if(%pl.canBuild) { %pl.canBuild = 0; if(isObject(%cube = %pl.targetCube)) %cube.delete(); cancel(%pl.targetLoop); %pl.targetCube = ""; }
	}
	
	function servercmdInstantUseBrick(%cl, %data)
	{
		if(!isObject(CastleDefense)) Parent::servercmdInstantUseBrick(%cl, %inv); return;
		//Tried to make TMBI compatible, but Nexus is retarded.
//		else if(%cl != $Builder || !isObject(%pl = %cl.player)) return;
//		else
//		{
//			if(%data.getID() == brickArcherIconData.getID()) { if(%pl.placingBot !$= "Archer") %update = 1; %pl.placingBot = "Archer"; }
//			else if(%data.getID() == brickMasonIconData.getID()) { if(%pl.placingBot !$= "Mason") %update = 1; %pl.placingBot = "Mason"; }
//			else if(%data.getID() == brickMedicIconData.getID()) { if(%pl.placingBot !$= "Medic") %update = 1; %pl.placingBot = "Medic"; }
//			else if(%data.getID() == brickBuildingIconData.getID())
//			{
//				if(!%pl.canBuild)
//				{
//					%pl.canBuild = 1; %update = 1;
//					if(isObject(%cube = %pl.targetCube))
//						%cube.delete();
//					%pl.currColor = "0.5 0.5 0.5";
//					if(%pl.isBuilding)
//					{
//						%cube = new ScriptObject() { class = "TargetCubeSO"; };
//						%cube.setNodeColor("ALL", "1 0 0 1");
//						%pl.targetLoop(%cube);
//					}
//				}
//			}
//			if(%update)
//			{
//				messageClient(%cl, 'MsgSetInvData', '', 0, brickArcherIconData.getID());
//				messageClient(%cl, 'MsgSetInvData', '', 1, brickMasonIconData.getID());
//				messageClient(%cl, 'MsgSetInvData', '', 2, brickMedicIconData.getID());
//				messageClient(%cl, 'MsgSetInvData', '', 3, 0);
//				messageClient(%cl, 'MsgSetInvData', '', 4, 0);
//				messageClient(%cl, 'MsgSetInvData', '', 5, 0);
//				messageClient(%cl, 'MsgSetInvData', '', 6, 0);
//				messageClient(%cl, 'MsgSetInvData', '', 7, 0);
//				messageClient(%cl, 'MsgSetInvData', '', 8, 0);
//				messageClient(%cl, 'MsgSetInvData', '', 9, brickBuildingIconData.getID());
//			}
//		}
	}
	
	function servercmdUseTool(%cl, %slot)
	{
		Parent::servercmdUseTool(%cl, %slot);
		if(!isObject(CastleDefense)) return;
		if(%cl == $Builder && isObject(%pl = %cl.player))
		{
			if(%pl.placingBot !$= "")
			{
				%pl.placingBot = ""; cancel(%pl.targetLoop);
				if(isObject(%cube = %pl.targetCube)) %cube.delete();
			}
			if(%pl.canBuild)
			{
				%pl.canBuild = 0; cancel(%pl.targetLoop);
				if(isObject(%cube = %pl.targetCube)) %cube.delete();
			}
		}
		CastleDefense.updateClient(%cl);
	}
	
	function servercmdUnuseTool(%cl)
	{
		Parent::servercmdUnuseTool(%cl);
		if(!isObject(CastleDefense)) return;
		if(%cl == $Builder && isObject(%pl = %cl.player))
		{
			if(%pl.placingBot !$= "")
			{
				%pl.placingBot = ""; cancel(%pl.targetLoop);
				if(isObject(%cube = %pl.targetCube)) %cube.delete();
			}
			if(%pl.canBuild)
			{
				%pl.canBuild = 0; cancel(%pl.targetLoop);
				if(isObject(%cube = %pl.targetCube)) %cube.delete();
			}
		}
		CastleDefense.updateClient(%cl);
	}
};
activatePackage("CastleDefense_Builder");

function Player::targetLoop(%pl, %cube)
{
	if(%pl.getState() $= "DEAD") { if(isObject(%cube)) %cube.delete(); return; }
	cancel(%pl.targetLoop); if(isObject(%obj = %pl.targetCube) && %obj != %cube) %obj.delete();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::StaticShapeObjectType | $Typemasks::TerrainObjectType;
	%ray = containerRaycast(%eye = %pl.getEyePoint(), vectorAdd(%eye, vectorScale(%pl.getEyeVector(), 20)), %mask);
	if(!isObject(%cube))
	{
		if(isObject(%obj = getWord(%ray, 0)))
		{
			if(%obj.builtCube)
			{
				cancel(%obj.returnColorSched); %obj.returnColorSched = %obj.schedule(100, "resetCubeColor");
				%obj.setNodeColor("ALL", 1 SPC (1 - getWord(%obj.color, 1)) SPC (1 - getWord(%obj.color, 2)) SPC getWord(%obj.color, 3));
			}
		}
	}
	else
	{
		%pl.targetCube = %cube;
		if(isObject(%pl.getMountedImage(0))) %pos = "0 0 -999";
		else if(isObject(%ray))
		{
			%pos = getWords(%ray, 1, 3); %normal = getWords(%ray, 4, 6);
			%pos = vectorAdd(%pos, vectorScale(%normal, 0.05));
			%x = mFloatLength((getWord(%pos, 0) - 1) / 2, 0) * 2 + 1;
			%y = mFloatLength((getWord(%pos, 1) - 1) / 2, 0) * 2 + 1;
			%z = mFloatLength((getWord(%pos, 2) - 1) / 2, 0) * 2 + 1;
			%pos = %x SPC %y SPC %z;
		}
		else {  %pos = "0 0 -999"; %brick = 1; }
		if(%pos !$= %cube.currPos) %cube.currPos = %pos; %cube.setTransform(%pos@" 1 0 0 0");
		if(mAbs(getWord(%pos, 0)) >= 100 || mAbs(getWord(%pos, 1)) >= 100 || getWord(%pos, 2) >= 26) %brick = 1;
		else if(mAbs(getWord(%pos, 0)) <= 4 && mAbs(getWord(%pos, 1)) <= 4 && mAbs(getWord(%pos, 2) - 10) <= 2) %brick = 1;
		else
		{
			initContainerBoxSearch(%pos, "1.95 1.95 1.95", $Typemasks::fxBrickAlwaysObjectType | $Typemasks::PlayerObjectType);
			while(isObject(%obj = containerSearchNext()))
				if(%obj.getType() & $Typemasks::fxBrickAlwaysObjectType) { if(%obj.isPlanted() && !%obj.isDead()) %brick = 1; }
				//else if(%obj.getClassName() $= "Player") { } else if(%obj.getClassName() $= "AIPlayer")
				else if(%obj.getType() & $Typemasks::PlayerObjectType)
				{
					%loc = %obj.getHackPosition();
					%x = mFloatLength((getWord(%loc, 0) - 1) / 2, 0) * 2 + 1;
					%y = mFloatLength((getWord(%loc, 1) - 1) / 2, 0) * 2 + 1;
					%z = mFloatLength((getWord(%loc, 2) - 1) / 2, 0) * 2 + 2;
					%loc = %x SPC %y SPC %z;
					if(vectorDist(%loc, vectorAdd(%pos, "0 0 -1")) <= 0.05 || vectorDist(%loc, vectorAdd(%pos, "0 0 1")) <= 0.05) %brick = 1;
				}
		}
		if(%brick) { if(%cube.canPlant) { %cube.canPlant = 0; %cube.setNodeColor("ALL", "1 0 0 1"); } }
		else { if(!%cube.canPlant) { %cube.canPlant = 1; %cube.setNodeColor("ALL", "0 1 0 1"); } }
	}
	%pl.targetLoop = %pl.schedule(50, "targetLoop", %cube);
}

function servercmdConfirmFortification(%cl)
{
	if(%cl == $Builder && CastleDefense.score >= 500)
	{
		CastleDefense.score -= 500;
		CastleDefense.maxHealth += 100;
		CastleDefense.updateAll();
	}
}

function servercmdFortification(%cl)
{ if(%cl == $Builder && CastleDefense.score >= 500) commandToClient(%cl, 'MessageBoxYesNo', "Are you sure?", "Buy Fortification for 500 Points?<br>This cannot be undone.", 'ConfirmFortification'); }

function servercmdSkip(%cl)
{
	if(%cl != $Builder || !isEventPending(%sched = CastleDefense.wait[CastleDefense.wait-1])) return;
	messageAll('MsgAdminForce', "\c2"@%cl.name@"\c3"@(getTimeRemaining(%sched)<=5000?" technically":"")@" skipped to the start of the next Wave!");
	for(%i=0;%i<CastleDefense.wait;%i++) cancel(CastleDefense.wait[%i]); CastleDefense.sendHorde();
}

function CD_UnitCost(%type, %mod)
{
	for(%i=0;%i<CastleDefense.getCount();%i++)
	{
		%obj = CastleDefense.getObject(%i);
		if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
		if(%obj.attacker || %obj.getState() $= "DEAD") continue;
		if(%obj.type $= %type) %count++;
	}
	%count += %mod;
	switch$(%type)
	{
		case "Archer": return 25 + (%count * 5);
		case "Knight": return 350 + (%count * 25);
		case "Mason": return 200 + (%count * 10);
		case "Medic": return 150 + (%count * 10);
		case "Wizard": return 350 + (%count * 50);
		default: return 0;
	}
}

function Player::targetLoopBot(%pl, %cube)
{
	if(%pl.getState() $= "DEAD") { if(isObject(%cube)) %cube.delete(); return; }
	cancel(%pl.targetLoop); if(isObject(%obj = %pl.targetCube) && %obj != %cube) %obj.delete();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::StaticShapeObjectType | $Typemasks::TerrainObjectType;
	%ray = containerRaycast(%eye = %pl.getEyePoint(), vectorAdd(%eye, vectorScale(%pl.getEyeVector(), 20)), %mask);
	if(!isObject(%cube)) return;
	%pl.targetCube = %cube;
	if(isObject(%pl.getMountedImage(0))) { %pos = "0 0 -999"; %brick = 1; }
	else if(isObject(%ray))
	{
		%pos = getWords(%ray, 1, 3); %normal = getWords(%ray, 4, 6);
		%pos = vectorAdd(%pos, vectorScale(%normal, 0.05));
		%x = mFloatLength((getWord(%pos, 0) - 1) / 2, 0) * 2 + 1;
		%y = mFloatLength((getWord(%pos, 1) - 1) / 2, 0) * 2 + 1;
		%z = mFloatLength((getWord(%pos, 2) - 1) / 2, 0) * 2;
		initContainerBoxSearch(vectorAdd(%x SPC %y SPC %z, "0 0 -1"), "1.95 1.95 1.95", %mask | $Typemasks::fxBrickAlwaysObjectType);
		while(isObject(%obj = containerSearchNext()))
		{
			if(%obj.getType() & $Typemasks::fxBrickAlwaysObjectType) { if(%obj.isPlanted() && !%obj.isDead()) %raise = 1; }
			else { %flag = 0; if(%obj == %cube) %flag = 1; if(!%flag) %raise = 1; }
		}
		if(%raise) %z += 2;
		%pos = %x SPC %y SPC %z;
	}
	else { %pos = "0 0 -999"; %brick = 1; }
	if(%pos !$= %cube.currPos) %cube.currPos = %pos; %cube.setTransform(%pos@" 1 0 0 0");
	if(mAbs(getWord(%pos, 0)) >= 50 || mAbs(getWord(%pos, 1)) >= 50) %brick = 1;
	else
	{
		initContainerBoxSearch(%pos, "1.95 1.95 3.95", %mask | $Typemasks::fxBrickAlwaysObjectType | $Typemasks::PlayerObjectType);
		while(isObject(%obj = containerSearchNext()))
		{
			if(%obj.getType() & $Typemasks::fxBrickAlwaysObjectType) { if(%obj.isPlanted() && !%obj.isDead()) %brick = 1; }
			else if(%obj.getClassName() $= "Player") { } else if(%obj.getClassName() $= "AIPlayer")
			{
				%loc = %obj.getHackPosition();
				%x = mFloatLength((getWord(%loc, 0) - 1) / 2, 0) * 2 + 1;
				%y = mFloatLength((getWord(%loc, 1) - 1) / 2, 0) * 2 + 1;
				%z = mFloatLength((getWord(%loc, 2) - 1) / 2, 0) * 2 + 2;
				%loc = %x SPC %y SPC %z;
				if(vectorDist(%loc, vectorAdd(%pos, "0 0 -2")) <= 0.05 || vectorDist(%loc, %pos) <= 0.05 || vectorDist(%loc, vectorAdd(%pos, "0 0 2")) <= 0.05) %brick = 1;
			}
			else { %flag = 1; if(%obj == %cube) %flag = 0; if(%flag) %brick = 1; }
		}
	}
	if(%brick) { if(%cube.canPlant) { %cube.canPlant = 0; %cube.setNodeColor("ALL", "1 0 0 1"); } }
	else { if(!%cube.canPlant) { %cube.canPlant = 1; %cube.setNodeColor("ALL", "0 1 0 1"); } }
	%pl.targetLoop = %pl.schedule(50, "targetLoopBot", %cube);
}
