function getFireAimVector(%start,%end,%g,%u)
{   
	%vec = vectorSub(%end,%start);
	if(%g <= 0)
		return vectorNormalize(%vec);
	%xx = getWord(%vec,0);
	%yy = getWord(%vec,1);
	%sx = mSqrt(%xx*%xx + %yy*%yy);
	%sy = getWord(%vec,2);
	if(%sx == 0 && %sy > 0)
		return "0 0 1";
	%a = (-0.5*%g*%sx*%sx) / (%u*%u);
	%b = %sx;
	%c = ((-0.5*%g*%sx*%sx) / (%u*%u)) - %sy;
	%d = %b*%b - 4*%a*%c;
	if(%d > 0)
	{
		%s1 = mATan((-%b+mSqrt(%d)) / (2*%a),1);
		%s2 = mATan((-%b-mSqrt(%d)) / (2*%a),1);
		if(%s1 < %s2) %ang = %s1;
		else %ang = %s2;
	}
	if(%d == 0) %ang = mATan((-%b) / (2*%a),1);
	if(%d < 0) return "0 0 1";
	%nVec = vectorNormalize(%xx SPC %yy);
	%retVec = vectorNormalize(getWord(%nVec,0) * mCos(%ang) SPC getWord(%nVec,1) * mCos(%ang) SPC mSin(%ang));
	return %retVec;
}

//old version
function getFireVector(%data, %obj, %targ)
{
	%speed = %data.muzzleVelocity;
	%start = %obj.getMuzzlePoint(0);
	%vel = vectorSub(%targ.getVelocity(), %obj.getVelocity());
	%end = %targ.getEyePoint();
	for(%i=0;%i<50;%i++)
	{
		%time = vectorDist(%start, %end) / %speed;
		%end = vectorAdd(%targ.getEyePoint(), vectorScale(%vel, %time));
	}
	%aim = getFireAimVector(%start, %end, %data.gravityMod * 10, %speed);
	return %aim;
}

function getFireVector(%data, %obj, %targ)
{
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType | $Typemasks::TerrainObjectType | $Typemasks::VehicleObjectType;
	%speed = %data.muzzleVelocity;
	%firePos = %obj.getMuzzlePoint(0);
	%hitPos = %targ.getEyePoint();
	%pos = %loc = %targ.getPosition();
	%vel = %trueVel = %targ.getVelocity();
	for(%i=0;%i<20;%i++)
	{
		%time = vectorDist(%firePos, %pos) / %speed;
		if(!isObject(firstWord(containerRaycast(%pos, vectorSub(%pos, "0 0 0.4"), %mask, %targ))))
			%vel = vectorAdd(%trueVel, vectorScale("0 0 -10", %time));
		%pos = vectorAdd(%loc, vectorScale(%vel, %time));
		%moveRay = containerRaycast(%loc, %pos, %mask, %targ);
		if(isObject(firstWord(%moveRay)))
			%pos = getWords(%moveRay, 1, 3);
	}
	%hitPos = vectorAdd(%hitPos, vectorSub(%pos, %loc));
	%vel = vectorSub(%targ.getVelocity(), %obj.getVelocity());
	%aim = getFireAimVector(%firePos, %hitPos, %data.gravityMod * 10, %speed);
	return %aim;
}