function servercmdFireball(%cl)
{
	if(isEventPending(%cl.cantCast)) return;
	if(isEventPending(%cl.cantCastFireball)) return;
	if(!isObject(%pl = %cl.player)) return;
	%los = %pl.getEyeVector(); %eye = %pl.getEyePoint();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%los, 50)), %mask, %pl);
	if(isObject(%obj = firstWord(%ray)) && (%obj.getType() & $Typemasks::PlayerObjectType) || (%obj.maxHealth !$= "" && %cl.attacker))
		CastFireball(%cl, %obj);
	if(isEventPending(%cl.cantCastFireball))
	{
		%pl.playThread(0, "activate");
		commandToClient(%cl, 'CastSpell', "Fireball");
	}
}

function servercmdNuke(%cl)
{
	if(isEventPending(%cl.cantCast)) return;
	if(isEventPending(%cl.cantCastNuke)) return;
	if(!isObject(%pl = %cl.player)) return;
	%los = %pl.getEyeVector(); %eye = %pl.getEyePoint();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%los, 50)), %mask, %pl);
	if(isObject(%obj = firstWord(%ray)) && (%obj.getType() & $Typemasks::PlayerObjectType) || (%obj.maxHealth !$= "" && %cl.attacker))
		CastNuke(%cl, %obj);
	if(isEventPending(%cl.cantCastNuke))
	{
		%pl.playThread(0, "activate");
		commandToClient(%cl, 'CastSpell', "Nuke");
	}
}

function servercmdChainLightning(%cl)
{
	if(isEventPending(%cl.cantCast)) return;
	if(isEventPending(%cl.cantCastChainLightning)) return;
	if(!isObject(%pl = %cl.player)) return;
	%los = %pl.getEyeVector(); %eye = %pl.getEyePoint();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%los, 20)), %mask, %pl);
	if(isObject(%obj = firstWord(%ray)) && (%obj.getType() & $Typemasks::PlayerObjectType))
		if(%cl.attacker ^ %obj.client.attacker) CastChainLightning(%cl, %obj);
	if(isEventPending(%cl.cantCastChainLightning))
	{
		%pl.playThread(0, "activate");
		commandToClient(%cl, 'CastSpell', "ChainLightning");
	}
}

function servercmdLeapJump(%cl)
{
	if(isEventPending(%cl.cantCast)) return;
	if(isEventPending(%cl.cantCastLeapJump)) return;
	if(!isObject(%pl = %cl.player)) return;
	%pl.addVelocity(vectorScale(%pl.getEyeVector(), 30));
	%cl.cantCast = schedule(1000, 0, "doNothing");
	%cl.cantCastLeapJump = schedule(20000, 0, "doNothing");
	commandToClient(%cl, 'CastSpell', "LeapJump");
}

function servercmdHealSelf(%cl)
{
	if(isEventPending(%cl.cantCast)) return;
	if(isEventPending(%cl.cantCastHealSelf)) return; CastHealSelf(%cl);
	if(isEventPending(%cl.cantCastHealSelf)) commandToClient(%cl, 'CastSpell', "HealSelf");
}

function servercmdHealOther(%cl)
{
	if(isEventPending(%cl.cantCast)) return;
	if(!isObject(%pl = %cl.player)) return;
	%los = %pl.getEyeVector(); %eye = %pl.getEyePoint();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%los, 20)), %mask, %pl);
	if(isObject(%obj = firstWord(%ray)) && (%obj.getType() & $Typemasks::PlayerObjectType))
		CastHealOther(%cl, %obj);
	if(isEventPending(%cl.cantCast))
	{
		%pl.playThread(0, "activate");
		commandToClient(%cl, 'CastSpell', "HealOther");
	}
}

function mEulerToAxis(%euler)
{
	 %euler = VectorScale(%euler, 0.0174533);
	 %matrix = MatrixCreateFromEuler(%euler);
	 return getWords(%matrix, 3, 6);
}

function servercmdConjureWall(%cl)
{
	if(isEventPending(%cl.cantCast)) return;
	if(isEventPending(%cl.cantCastConjureWall)) return;
	if(!isObject(%pl = %cl.player)) return;
	%los = %pl.getEyeVector(); %eye = %pl.getEyePoint();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%los, 10)), %mask, %pl);
	if(isObject(firstWord(%ray)))
	{
		%wallPos = vectorAdd(getWords(%ray, 1, 3), %normal = getWords(%ray, 4, 6)); %absNorm = %normal;
		%for = %pl.getForwardVector(); %plAng = mFloatLength(mAtan(getWord(%for, 0), getWord(%for, 1)) / $PI * 2, 0);
		%wallAng = %plAng & 1; for(%i=0;%i<3;%i++) %absNorm = setWord(%absNorm, %i, mFloatLength(mAbs(getWord(%absNorm, %i)), 3));
		if(vectorDist(%absNorm, "0 0 1") <= 0.005 || vectorDist(%absNorm, %wallAng ? "0 1 0" : "1 0 0") <= 0.005)
			%wallPos = vectorAdd(%wallPos, vectorScale(%normal, 4));
		for(%i=0;%i<3;%i++) %wallPos = setWord(%wallPos, %i, mFloatLength((getWord(%wallPos, %i) - 1) / 2, 0) * 2 + 1);
		CastConjureWall(%cl, %wallPos, %wallAng ? "0 0 1 1.5708" : "1 0 0 0");
	}
	else
	{
		%diff = vectorSub(%eye, %wallPos = vectorAdd(%eye, vectorScale(%los, 6)));
		%yaw = mAtan(getWord(%diff, 0), getWord(%diff, 1)) + 3.14159265; if(%yaw >= 3.14159265) %yaw -= 6.2831853;
		%rot = mEulerToAxis(mAsin(vectorDot(vectorNormalize(%diff), "0 0 1"))*-57.2958@" 0 "@%yaw*-57.2958);
		CastConjureWall(%cl, %wallPos, %rot);
	}
	if(isEventPending(%cl.cantCastConjureWall))
	{
		%pl.playThread(0, "activate");
		commandToClient(%cl, 'CastSpell', "ConjureWall");
	}
}

function servercmdGustOfWind(%cl)
{
	if(isEventPending(%cl.cantCast)) return;
	if(isEventPending(%cl.cantCastGustOfWind)) return;
	if(!isObject(%pl = %cl.player)) return;
	initContainerRadiusSearch(%pos = %pl.getPosition(), 50, $Typemasks::PlayerObjectType);
	while(isObject(%obj = containerSearchNext()))
	{
		if(!(%obj.attacker ^ %pl.attacker)) continue;
		%dist = vectorDist(%pos, %loc = %obj.getHackPosition()) / 50;
		if(%dist > 1) continue; %dist = 1 - %dist;
		%force = %dist * %dist * 25;
		%push = vectorNormalize(vectorSub(%loc, %pos));
		%final = vectorAdd(%obj.getVelocity(), vectorScale(%push, %force));
		if(getWord(%final, 2) > 20) %final = setWord(%final, 2, 20);
		%obj.setVelocity(%final);
	}
	%pl.playThread(0, "activate2");
	%cl.cantCast = schedule(1000, 0, "doNothing");
	%cl.cantCastGustOfWind = schedule(10000, 0, "doNothing");
	commandToClient(%cl, 'CastSpell', "GustOfWind");
}

function servercmdConfusion(%cl)
{
	if(isEventPending(%cl.cantCast)) return;
	if(isEventPending(%cl.cantCastConfusion)) return;
	if(!isObject(%pl = %cl.player)) return;
	%los = %pl.getEyeVector(); %eye = %pl.getEyePoint();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%los, 20)), %mask, %pl);
	if(isObject(%obj = firstWord(%ray)) && (%obj.getType() & $Typemasks::PlayerObjectType))
		if(%cl.attacker ^ %obj.client.attacker)
			CastConfusion(%cl, %obj);
	if(isEventPending(%cl.cantCastConfusion))
	{
		%pl.playThread(0, "activate");
		commandToClient(%cl, 'CastSpell', "Confusion");
	}
}

function servercmdMassConfuse(%cl)
{
	if(isEventPending(%cl.cantCast)) return;
	if(isEventPending(%cl.cantCastMassConfuse)) return;
	if(!isObject(%pl = %cl.player)) return;
	%los = %pl.getEyeVector(); %eye = %pl.getEyePoint();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%los, 50)), %mask, %pl);
	if(isObject(%obj = firstWord(%ray)) && (%obj.getType() & $Typemasks::PlayerObjectType))
		CastMassConfuse(%cl, %obj);
	if(isEventPending(%cl.cantCastMassConfuse))
	{
		%pl.playThread(0, "activate");
		commandToClient(%cl, 'CastSpell', "MassConfuse");
	}
}

function servercmdRaiseCorpse(%cl)
{
	if(isEventPending(%cl.cantCast)) return;
	if(isEventPending(%cl.cantCastRaiseCorpse)) return;
	if(!isObject(%pl = %cl.player)) return;
	initContainerRadiusSearch(%pl.getHackPosition(), 8, $Typemasks::CorpseObjectType);
	while(isObject(%obj = containerSearchNext()))
	{
		%zombie = %obj.CreateZombie(%cl);
		if(isObject(%zombie))
			%raisedCorpse = 1;
	}
	if(!%raisedCorpse) return;
	%cl.cantCast = schedule(1000, 0, "doNothing");
	%cl.cantCastRaiseCorpse = schedule(30000, 0, "doNothing");
	commandToClient(%cl, 'CastSpell', "RaiseCorpse");
}

function Player::CreateZombie(%pl, %owner)
{
	if(%pl.getState() !$= "DEAD" || !isObject(%owner)) return;
	%zombie = CreateZombieAtTransform(%pl.getTransform(), %owner);
	if(isObject(%zombie)) %pl.delete(); return %zombie;
}

function CreateZombieAtTransform(%trans, %owner)
{
	if(!isObject(%owner)) return;
	if(isObject(%group = %owner.zombieGroup) && %group.getCount() >= 20) return;
	%zombie = new AIPlayer()
	{
		attacker = %owner.attacker;
		zombieOwner = %owner;
		datablock = PlayerNoJet;
		position = "0 0 -999";
		type = "Zombie";
	};
	%skinTone = mSqrt(getRandom(16, 64) / 100);
	%skinColor = vectorScale(%skinTone@" 1 "@%skinTone, 0.5)@" 1";
	%zombie.setNodeColor("headskin", %skinColor);
	%zombie.setNodeColor("lhand", %skinColor);
	%zombie.setNodeColor("rhand", %skinColor);
	%zombie.setNodeColor("lshoe", %skinColor);
	%zombie.setNodeColor("rshoe", %skinColor);
	%zombie.setNodeColor("larm", "0.5 0.5 0.5 1");
	%zombie.setNodeColor("rarm", "0.5 0.5 0.5 1");
	%zombie.setNodeColor("chest", "0.5 0.5 0.5 1");
	%zombie.setNodeColor("pants", "0.5 0.5 0.5 1");
	%zombie.setTransform(%trans);
	%zombie.playThread(1, "armReadyBoth");
	if(CastleDefense.idleClients <= 0)
	{
		%zombie.client = new AIConnection()
		{
			alwaysNamed = 0; attacker = 1;
			botName = %owner.name@"'s Zombie";
			player = %zombie; score = 5;
		};
		$Clients++;
	}
	else
	{
		%this = CastleDefense.idleClient[CastleDefense.idleClients--];
		%zombie.client = %this; %this.alwaysNamed = 0; %this.botName = %owner.name@"'s Zombie"; %this.player = %zombie;
		%this.attacker = 1; %this.score = 5; %this.unreducable = 0;
	}
	CastleDefense.add(%zombie);
	%zombie.schedule(1000, "ZombieAILoop", %owner, getSimTime());
	if(!isObject(%owner.zombieGroup))
		%owner.zombieGroup = new SimSet();
	%owner.zombieGroup.add(%zombie);
	return %zombie;
}

function servercmdOrderHorde(%cl, %order)
{
	if(!isObject(%pl = %cl.player)) return;
	%eye = %pl.getEyePoint(); %los = %pl.getEyeVector();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType
		| $Typemasks::StaticShapeObjectType | $Typemasks::TerrainObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%los, 200)), %mask, %pl);
	if(isObject(%hit = firstWord(%ray)))
	{
		if(%hit.getType() & $Typemasks::PlayerObjectType)
			%target = %hit;
		else %target = getWords(%ray, 1, 3);
	}
	else %target = "";
	if(%order == 1) %cl.ZombieCommand = %cl.ZombieCommand;   //Make queueing commands
	else if(%order !$= "") %cl.ZombieCommand = %order;
	else %cl.ZombieCommand = %target;
	%pl.playThread(0, "activate");
}

function AIPlayer::ZombieAILoop(%zombie, %owner, %last)
{
	if(!isObject(%owner)) { %zombie.kill(); return; }
	%zombie.attacker = %owner.attacker;
	%zombie.client.attacker = %owner.attacker;
	if(%zombie.getState() $= "DEAD") return;
	cancel(%zombie.AILoop);
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	%pos = %zombie.getHackPosition();
	%group = %owner.zombieGroup;
	%zombies = %group.getCount();
	for(%i=0;%i<%zombies;%i++)
	{
		%friend = %group.getObject(%i);
		if(%friend == %zombie) continue;
		if(%friend.getState() $= "DEAD") continue;
		if(vectorDist(%pos, %friend.getHackPosition()) <= 8)
			%friend[-1+%friends++] = %friend;
	}
	if(isObject(%heal = %owner.player) && vectorDist(%pos, %heal.getHackPosition()) <= 8)
	{
		%healAmt = getMin(%heal.getDamageLevel(), 50 - %zombie.getDamageLevel());
		if(%healAmt > 0)
		{
			%heal.setDamageLevel(%heal.getDamageLevel() - %healAmt);
			%zombie.setDamageLevel(%zombie.getDamageLevel() + %healAmt);
		}
	}
	if(%friends != 0)
	{
		%HPFlow = %time / %friends * 20;
		for(%i=0;%i<%friends;%i++)
		{
			%HPDiff = %zombie.getDamageLevel() - %friend.getDamageLevel();
			%HPDiff = mClampF(%HPDiff, -%HPFlow, %HPFlow);
			%zombie.setDamageLevel(%zombie.getDamageLevel() - %HPDiff);
			%friend.setDamageLevel(%friend.getDamageLevel() + %HPDiff);
		}
	}
	%zombie.setDamageLevel(%zombie.getDamageLevel() - %time);
	%target = %owner.ZombieCommand;
	if(getWordCount(%target) != 1 || !isObject(%target) || !(%target.attacker ^ %zombie.attacker))
	{
		%count = ClientGroup.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(!isObject(%pl = %cl.player)) continue;
			if(%pl.getState() $= "DEAD") continue;
			if(!(%pl.attacker ^ %zombie.attacker)) continue;
			if(vectorDist(%pos, %pl.getHackPosition()) > 12) continue;
			%list[-1+%list++] = %pl;
		}
		%count = CastleDefense.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%pl = CastleDefense.getObject(%i);
			if(!(%pl.getType() & $Typemasks::PlayerObjectType)) continue;
			if(%pl.getState() $= "DEAD") continue;
			if(!(%pl.attacker ^ %zombie.attacker)) continue;
			if(%pl.zombieOwner == %zombie.zombieOwner) continue;
			if(vectorDist(%pos, %pl.getHackPosition()) > 12) continue;
			%list[-1+%list++] = %pl;
		}
		for(%i=0;%i<%list;%i++)
		{
			%dist = vectorDist(%pos, %list[%i].getHackPosition());
			if(%dist < %closest || %closest $= "")
			{ %closest = %dist; %targ = %list[%i]; }
		}
		if(isObject(%targ))
		{
			%zombie.setAimVector(%aim = vectorSub(%targ.getEyePoint(), %zombie.getEyePoint()));
			%zombie.setMoveY(1);
			%dot = vectorDot(%aim, %zombie.getEyeVector());
			%eye = %zombie.getEyePoint();
			%vec = %zombie.getEyeVector();
			for(%i=0;%i<4;%i++)
			{
				%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%vec, 4)), $Typemasks::PlayerObjectType, %zombie,
					%ignore0, %ignore1, %ignore2, %ignore3);
				if(firstWord(%ray) == %targ && vectorDist(%zombie.lastAttackTime, %now) >= 350 + %zombie.getDamageLevel() * 1.5)
				{
					%zombie.lastAttackTime = %now; %zombie.playThread(0, "activate2");
					%targ.damage(%owner, %targ.getHackPosition(), 25, $DamageType::ZombieHorde);
					break;
				}
				else if(firstWord(%ray == 0)) break;
				else %ignore[%i] = firstWord(%ray);
			}
			%zombie.AILoop = %zombie.schedule(16, "ZombieAILoop", %owner, %now);
			return;
		}
	}
	if(%target $= "Wander")
	{
		if(vectorDist(%zombie.lastWanderTime, %now) >= 3000)
		{
			%zombie.lastWanderTime = %now; %ang = getRandom() * 2 * $PI;
			%zombie.wanderingGoal = vectorAdd(%zombie.getEyePoint(), vectorScale(mSin(%ang) SPC mCos(%ang), 20));
		}
		%zombie.setAimVector(vectorSub(%zombie.wanderingGoal, %zombie.getEyePoint()));
		%zombie.setMoveY(vectorDist(%pos, %zombie.wanderingGoal) / 5);
	}
	else if(%target $= "" && isObject(%pl = %owner.player))
	{
		%zombie.setAimVector(vectorSub(%pl.getEyePoint(), %zombie.getEyePoint()));
		%zombie.setMoveY(vectorDist(%pos, %pl.getHackPosition()) - 5);
	}
	else if(getWordCount(%target) == 1)
	{
		if(%target.getState() $= "DEAD" || !isObject(%target)) { %owner.ZombieCommand = ""; %target = ""; }
		else if(%target == %zombie)
		{
			%zombie.AILoop = %zombie.schedule(16, "ZombieAILoop", %owner);
			%zombie.setAimVector(%zombie.getForwardVector());
			%zombie.setMoveY(0); return;
		}
		else
		{
			%zombie.setAimVector(%aim = vectorSub(%target.getEyePoint(), %zombie.getEyePoint()));
			if(%target.attacker ^ %zombie.attacker)
			{
				%zombie.setMoveY(1);
				%dot = vectorDot(%aim, %zombie.getEyeVector());
				if(vectorDist(%pos, %target.getHackPosition()) <= 4 && %dot >= 0.9975
					&& vectorDist(%zombie.lastAttackTime, %now) >= 500)
				{
					%zombie.lastAttackTime = %now; %zombie.playThread(0, "activate2");
					%target.damage(%owner, %target.getHackPosition(), 25, $DamageType::ZombieHorde);
				}
			}
			else %zombie.setMoveY(vectorDist(%pos, %target.getHackPosition()) - 5);
		}
	}
	else { %zombie.setAimVector(vectorSub(%target, %zombie.getEyePoint())); %zombie.setMoveY(1); }
	%zombie.AILoop = %zombie.schedule(16, "ZombieAILoop", %owner, %now);
}