function CastFireball(%caster, %target)
{
	if(isEventPending(%caster.cantCast) || isEventPending(%caster.cantCastFireball)) return;
	(%shape = new StaticShape()
	{
		client = %caster;
		datablock = CastleDefenseSphere;
		position = (%pos = (%target.getType() & $Typemasks::PlayerObjectType ? %target.getHackPosition() : %target.getPosition()));
		scale = "0.05 0.05 0.05";
	}).setNodeColor("ALL", "1.0 1.0 1.0 1.0");
	CD_Fireball(%shape, %pos, %now = getSimTime(), %now);
	%caster.cantCast = schedule(1000, 0, "doNothing");
	%caster.cantCastFireball = schedule(10000, 0, "doNothing");
}

function CD_Fireball(%shape, %pos, %start, %last)
{
	%dist = vectorDist(%last, %now = getSimTime()) / 1000;
	%time = vectorDist(%start, %now) / 3000;
	if(%time >= 1)
	{
		if((%kills = (%cl = %shape.client).fireballBotsKilled) != 0)
		{
			%num = NumToWord(%kills); %num = strUpr(getSubStr(%num, 0, 1)) @ getSubStr(%num, 1, strLen(%num) - 1);
			messageAll('', %cl.name@" <bitmap:Add-Ons/Server_CastleDefense/CI_Fireball> "@(%kills==1?"Bot":%num@" bots"));
			%cl.fireballBotsKilled = 0;
		}
		%shape.delete();
		return;
	}
	%col = mSin(%time * 3.14159265); %size = %col * 5;
	if(%time <= 0.5) %shape.setNodeColor("ALL", "1.0 1.0 "@(1-%col)@" 1.0");
	else %shape.setNodeColor("ALL", "1.0 "@%col@" 0.0 1.0");
	%shape.setScale(%size SPC %size SPC %size);
	%shape.setTransform(%pos@" 0 0 1 "@(%time*3.14159265));
	for(%i=0;%i<CastleDefense.getCount();%i++)
	{
		%obj = CastleDefense.getObject(%i);
		if(!(%obj.getType() & $Typemasks::PlayerObjectType) || %obj.getState() $= "DEAD") continue;
		if(vectorDist(%loc = %obj.getHackPosition(), %pos) <= %size)
			%obj.damage(%shape.client, %loc, %dist * 35, $DamageType::Fireball);
	}
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%cl = ClientGroup.getObject(%i);
		if(!isObject(%obj = %cl.player) || %obj.getState() $= "DEAD") continue;
		if(vectorDist(%loc = %obj.getHackPosition(), %pos) <= %size)
			%obj.damage(%shape.client, %loc, %dist * 20, $DamageType::Fireball);
	}
	if(%shape.client.attacker)
	{
		initContainerRadiusSearch(%pos, %size, $Typemasks::StaticShapeObjectType);
		while(isObject(%obj = containerSearchNext()))
		{
			if(%obj.maxHealth !$= "")
			{
				%obj.health -= %dist * 10;
				if(%obj.health <= 0) %obj.delete();
				else
				{
					%col = %obj.health / (%obj.maxHealth * 2);
					%obj.setNodeColor("ALL", %obj.color = %col SPC %col SPC %col@" 1");
				}
			}
		}
	}
	schedule(50, 0, "CD_Fireball", %shape, %pos, %start, %now);
}

function CastNuke(%caster, %target)
{
	if(isEventPending(%caster.cantCast) || isEventPending(%caster.cantCastNuke)) return;
	(%shape = new StaticShape()
	{
		client = %caster;
		datablock = CastleDefenseSphere;
		position = (%pos = (%target.getType() & $Typemasks::PlayerObjectType ? %target.getHackPosition() : %target.getPosition()));
		scale = "0.05 0.05 0.05";
	}).setNodeColor("ALL", "1.0 1.0 1.0 1.0");
	CD_Nuke(%shape, %pos, %now = getSimTime(), %now);
	%caster.cantCast = schedule(1000, 0, "doNothing");
	%caster.cantCastNuke = schedule(150000, 0, "doNothing");
}

function CD_Nuke(%shape, %pos, %start, %last)
{
	%dist = vectorDist(%last, %now = getSimTime()) / 1000;
	%time = vectorDist(%start, %now) / 30000;
	if(%time >= 1)
	{
		if((%kills = (%cl = %shape.client).fireballBotsKilled) != 0)
		{
			%num = NumToWord(%kills); %num = strUpr(getSubStr(%num, 0, 1)) @ getSubStr(%num, 1, strLen(%num) - 1);
			messageAll('', %cl.name@" <bitmap:Add-Ons/Server_CastleDefense/CI_Fireball> "@(%kills==1?"Bot":%num@" bots"));
			%cl.fireballBotsKilled = 0;
		}
		%shape.delete();
		return;
	}
	%col = mSin(%time * 3.14159265); %size = %col * 12.5;
	if(%time <= 0.5) %shape.setNodeColor("ALL", "1.0 1.0 "@(1-%col)@" 1.0");
	else %shape.setNodeColor("ALL", "1.0 "@%col@" 0.0 1.0");
	%shape.setScale(%size SPC %size SPC %size);
	%shape.setTransform(%pos@" 0 0 1 "@(%time*3.14159265));
	for(%i=0;%i<CastleDefense.getCount();%i++)
	{
		%obj = CastleDefense.getObject(%i);
		if(!(%obj.getType() & $Typemasks::PlayerObjectType) || %obj.getState() $= "DEAD") continue;
		if(vectorDist(%loc = %obj.getHackPosition(), %pos) <= %size)
			%obj.damage(%shape.client, %loc, %dist * 35, $DamageType::Fireball);
	}
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%cl = ClientGroup.getObject(%i);
		if(!isObject(%obj = %cl.player) || %obj.getState() $= "DEAD") continue;
		if(vectorDist(%loc = %obj.getHackPosition(), %pos) <= %size)
			%obj.damage(%shape.client, %loc, %dist * 20, $DamageType::Fireball);
	}
	if(%shape.client.attacker)
	{
		initContainerRadiusSearch(%pos, %size, $Typemasks::StaticShapeObjectType);
		while(isObject(%obj = containerSearchNext()))
		{
			if(%obj.maxHealth !$= "")
			{
				%obj.health -= %dist * 10;
				if(%obj.health <= 0) %obj.delete();
				else
				{
					%col = %obj.health / (%obj.maxHealth * 2);
					%obj.setNodeColor("ALL", %obj.color = %col SPC %col SPC %col@" 1");
				}
			}
		}
	}
	schedule(50, 0, "CD_Nuke", %shape, %pos, %start, %now);
}

function CastChainLightning(%caster, %target)
{
	if(isEventPending(%caster.cantCast) || isEventPending(%caster.cantCastChainLightning)) return;
	(%shape = new StaticShape()
	{
		client = %caster;
		datablock = CastleDefenseCylinder;
		position = "0 0 -999";
		scale = "0.05 0.05 0.05";
	}).setNodeColor("ALL", "1.0 1.0 1.0 1.0");
	%startTarg = %caster.player; %endTarg = %target;
	%diff = vectorSub(%pos = %startTarg.getHackPosition(), %loc = %endTarg.getHackPosition());
	%yaw = mAtan(getWord(%diff, 0), getWord(%diff, 1)) + 3.14159265; if(%yaw >= 3.14159265) %yaw -= 6.2831853;
	%shape.setScale(0.2 SPC vectorDist(%pos, %loc) SPC 0.2); %endTarg.damage(%shape.client, %loc, 50, $DamageType::Chain_Lightning);
	%shape.setTransform(vectorScale(vectorAdd(%pos, %loc), 0.5) SPC mEulerToAxis((mAsin(vectorDot(vectorNormalize(%diff), "0 0 1"))*-57.2958@" 0 "@%yaw*-57.2958)));
	%shape.zapped[%endTarg] = 1; CD_ChainLightning(%shape, %startTarg, %endTarg, 45, getSimTime());
	%caster.cantCast = schedule(1000, 0, "doNothing");
	%caster.cantCastChainLightning = schedule(10000, 0, "doNothing");
}

function CD_ChainLightning(%shape, %startTarg, %endTarg, %damage, %start)
{
	%time = vectorDist(%start, getSimTime()) / 200;
	if(!isObject(%startTarg) || !isObject(%endTarg))
	{
		if((%kills = (%cl = %shape.client).lightningBotsKilled) != 0)
		{
			%num = NumToWord(%kills); %num = strUpr(getSubStr(%num, 0, 1)) @ getSubStr(%num, 1, strLen(%num) - 1);
			messageAll('', %cl.name@" <bitmap:Add-Ons/Server_CastleDefense/CI_Chain_Lightning> "@(%kills==1?"Bot":%num@" bots"));
			%cl.lightningBotsKilled = 0;
		}
		%shape.delete();
		return;
	}
	%diff = vectorSub(%pos = %startTarg.getHackPosition(), %loc = %endTarg.getHackPosition());
	%yaw = mAtan(getWord(%diff, 0), getWord(%diff, 1)) + 3.14159265; if(%yaw >= 3.14159265) %yaw -= 6.2831853;
	%shape.setScale(0.2 SPC vectorDist(%pos, %loc) SPC 0.2);
	%shape.setTransform(vectorScale(vectorAdd(%pos, %loc), 0.5) SPC mEulerToAxis((mAsin(vectorDot(vectorNormalize(%diff), "0 0 1"))*-57.2958@" 0 "@%yaw*-57.2958)));
	if(%time >= 1)
	{
		CD_LightningRod(%shape, %startTarg, %endTarg, getSimTime());
		for(%i=0;%i<CastleDefense.getCount();%i++)
		{
			%obj = CastleDefense.getObject(%i);
			if(!(%obj.getType() & $Typemasks::PlayerObjectType) || %obj.getState() $= "DEAD") continue;
			if(!(%obj.client.attacker ^ %shape.client.attacker) || (%obj == %endTarg)) continue;
			if(vectorDist(%loc = %obj.getHackPosition(), %pos) <= (%damage / 2.5)) %list[-1+%list++] = %obj;
		}
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(!isObject(%obj = %cl.player) || %obj.getState() $= "DEAD") continue;
			if(!(%obj.client.attacker ^ %shape.client.attacker) || (%obj == %endTarg)) continue;
			if(vectorDist(%loc = %obj.getHackPosition(), %pos) <= (%damage / 2.5)) %list[-1+%list++] = %obj;
		}
		%damage -= 5;
		if(%list == 0 || %damage <= 0)
		{
			if((%kills = (%cl = %shape.client).lightningBotsKilled) != 0)
			{
				%num = NumToWord(%kills); %num = strUpr(getSubStr(%num, 0, 1)) @ getSubStr(%num, 1, strLen(%num) - 1);
				messageAll('', %cl.name@" <bitmap:Add-Ons/Server_CastleDefense/CI_Chain_Lightning> "@(%kills==1?"Bot":%num@" bots"));
				%cl.lightningBotsKilled = 0;
			}
			return;
		}
		(%shape = new StaticShape()
		{
			client = %shape.client;
			datablock = CastleDefenseCylinder;
			position = "0 0 -999";
			scale = "0.05 0.05 0.05";
		}).setNodeColor("ALL", "1.0 1.0 1.0 1.0");
		%startTarg = %endTarg; %endTarg = %list[getRandom(0, %list - 1)];
		%endTarg.damage(%shape.client, %endTarg.getHackPosition(), %damage, $DamageType::Chain_Lightning);
		%shape.setNodeColor("ALL", "1.0 1.0 "@(%damage / 50)@" 1.0"); %start = getSimTime();
	}
	schedule(50, 0, "CD_ChainLightning", %shape, %startTarg, %endTarg, %damage, %start);
}

function CD_LightningRod(%shape, %startTarg, %endTarg, %start)
{
	%time = vectorDist(%start, getSimTime()) / 800; if(!isObject(%startTarg) || !isObject(%endTarg) || %time >= 1) { %shape.delete(); return; }
	%diff = vectorSub(%pos = %startTarg.getHackPosition(), %loc = %endTarg.getHackPosition());
	%yaw = mAtan(getWord(%diff, 0), getWord(%diff, 1)) + 3.14159265; if(%yaw >= 3.14159265) %yaw -= 6.2831853;
	%shape.setScale(0.2 SPC vectorDist(%pos, %loc) SPC 0.2);
	%shape.setTransform(vectorScale(vectorAdd(%pos, %loc), 0.5) SPC mEulerToAxis((mAsin(vectorDot(vectorNormalize(%diff), "0 0 1"))*-57.2958@" 0 "@%yaw*-57.2958)));
	schedule(50, 0, "CD_LightningRod", %shape, %startTarg, %endTarg, %start);
}

function CastHealSelf(%caster)
{
	if(isEventPending(%caster.cantCast) || isEventPending(%caster.cantCastHealSelf) || !isObject(%pl = %caster.player) || %pl.getDamageLevel() == 0) return;
	%pl.setDamageLevel(%pl.getDamageLevel() - 50); CastleDefense.updateClient(%caster);
	%pl.calcifiedDamage -= 50; if(%pl.calcifiedDamage < 0) %pl.calcifiedDamage = 0;
	if(isObject(%name = %pl.shapeName))
	{
		%damage = 1 - %pl.getDamagePercent();
		%name.setShapeName(mFloatLength(%damage * 100, 0));
		if(%damage >= 0.5) %name.setShapeNameColor(((1 - %damage) * 2)@" 1 0");
		else %name.setShapeNameColor("1 "@(%damage * 2)@" 0");
	}
	%caster.cantCast = schedule(1000, 0, "doNothing");
	%caster.cantCastHealSelf = schedule(10000, 0, "doNothing");
}

function CastHealOther(%caster, %target)
{
	%damage = %target.getDamageLevel();
	if(isEventPending(%caster.cantCast) || (%damage == 0 && %target.attacker == %caster.attacker)) return;
	if(%target.attacker ^ %caster.attacker)
	{
		return;
		%target.damage(%caster, %target.getHackPosition(), 200, $DamageType::Generic);
		%target.calcifiedDamage += 10;
	}
	else
	{
		%target.calcifiedDamage -= (%caster.getClassName() $= "GameConnection" || %target.getClassName() $= "Player" ? 5 : 1); if(%target.calcifiedDamage < 0) %target.calcifiedDamage = 0;
		%target.setDamageLevel(getMax(%damage - 50, %target.calcifiedDamage));
	}
	if(isObject(%name = %target.shapeName))
	{
		%damage = 1 - %target.getDamagePercent();
		%name.setShapeName(mFloatLength(%damage * 100, 0));
		if(%damage >= 0.5) %name.setShapeNameColor(((1 - %damage) * 2)@" 1 0");
		else %name.setShapeNameColor("1 "@(%damage * 2)@" 0");
	}
	CastleDefense.updateClient(%target.client);
	%caster.cantCast = schedule(1000, 0, "doNothing");
}

function CastConjureWall(%caster, %wallPos, %wallAng)
{
	if(isEventPending(%caster.cantCast) || isEventPending(%caster.cantCastConjureWall)) return;
	(%shape = new StaticShape()
	{
		datablock = CastleDefenseCube_Col1;
		position = %wallPos;
		scale = "5 1 5";
	}).setNodeColor("ALL", "0 0 1 1");
	%shape.setTransform(%wallPos SPC %wallAng);
	%shape.schedule(20000, "delete");
	%caster.cantCast = schedule(1000, 0, "doNothing");
	%caster.cantCastConjureWall = schedule(60000, 0, "doNothing");
}

function CastConfusion(%caster, %target, %override)
{
	if(!%override) { if(isEventPending(%caster.cantCast) || isEventPending(%caster.cantCastConfusion)) return; }
	if(%target.getClassName() $= "Player" || %target.confused) return;
	%target.confused = 1;
	(%shape = new StaticShape()
	{
		client = %caster;
		datablock = CastleDefenseSphere;
		position = %target.getMuzzlePoint(2);
		scale = "1 1 1";
	}).setNodeColor("ALL", "0.5 0.0 1.0 1.0");
	CD_Confusion(%shape, %target, getSimTime());
	if(!%override)
	{
		%caster.cantCast = schedule(1000, 0, "doNothing");
		%caster.cantCastConfusion = schedule(5000, 0, "doNothing");
	}
}

function CD_Confusion(%shape, %target, %start)
{
	if(!isObject(%shape)) { %target.confused = 0; return; } %time = vectorDist(%start, getSimTime()) / 1000;
	if(!%target.confused && %time >= 1) { %shape.delete(); return; }
	if(%time >= 30 || !isObject(%target) || %target.getState() $= "DEAD")
	{ %target.confused = 0; %shape.delete(); return; }
	%shape.setTransform(%target.getMuzzlePoint(2) SPC getWords(%target.getTransform(), 3, 6));
	schedule(50, 0, "CD_Confusion", %shape, %target, %start);
}

function CastMassConfuse(%caster, %target)
{
	if(isEventPending(%caster.cantCastMassConfuse) || isEventPending(%caster.cantCast)) return;
	(%shape = new StaticShape()
	{
		client = %caster;
		datablock = CastleDefenseSphere;
		position = (%pos = %target.getHackPosition());
		scale = "0.05 0.05 0.05";
	}).setNodeColor("ALL", "0.5 0.0 1.0 1.0");
	CD_MassConfuse(%shape, %pos, getSimTime());
	%caster.cantCast = schedule(1000, 0, "doNothing");
	%caster.cantCastMassConfuse = schedule(60000, 0, "doNothing");
}

function CD_MassConfuse(%shape, %pos, %start)
{
	%time = vectorDist(%start, getSimTime()) / 5000;
	if(%time >= 1) { %shape.delete(); return; }
	%size = mSin(%time * 3.14159265) * 10;
	%shape.setScale(%size SPC %size SPC %size);
	%shape.setTransform(%pos@" 0 0 1 "@(%time*3.14159265));
	for(%i=0;%i<CastleDefense.getCount();%i++)
	{
		%obj = CastleDefense.getObject(%i);
		if(!(%obj.getType() & $Typemasks::PlayerObjectType) || %obj.getState() $= "DEAD") continue;
		if(vectorDist(%loc = %obj.getHackPosition(), %pos) <= %size)
			if((%obj.attacker ^ %shape.client.attacker) && !%obj.confused)
				CastConfusion(%shape.client, %obj, 1);
	}
	schedule(50, 0, "CD_MassConfuse", %shape, %pos, %start);
}

function ConfuseAll(%cl)
{
	for(%i=0;%i<CastleDefense.getCount();%i++)
	{
		%obj = CastleDefense.getObject(%i);
		if(!(%obj.getType() & $Typemasks::PlayerObjectType)) continue;
		if(%obj.attacker || getRandom(0, 1)) continue;
		CastConfusion(%cl, %obj, 1);
	}
}
